// == carCost2 functions

/*
Copyright 2013. Daniel Hellerstein (danielh@crosslink.net)

This file is part of carCosts2.

    carCosts2 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    carCosts2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with carCosts2.  If not, see <http://www.gnu.org/licenses/>.


*/

//===========================
// chose between a car and a car collction
function setupCollection(thisElement,changedElement,icall,alist,origId,cElem) {
  var a1,igroup,goo,showCar;
  igroup=readAttribute(thisElement,'group',0);

  if (origId==0)   return {status:'nosave'};
  showCar=get_elemValue(thisElement);

  a2=readAttribute(thisElement,'refValue',0);

//collectionTable_*"       id="carTable_*"
  if (showCar==="0") {                          // turn on collection
        turnDisplayOn('carTable_'+a2,'none');
        turnDisplayOn('collectionTable_'+a2);
 }
  if (showCar=="1") {                          // turn on car
       turnDisplayOn('carTable_'+a2 );
        turnDisplayOn('collectionTable_'+a2,'none');
 }


  return {status:'nosave'};
}

//===============================
//  if co2 per gallon field is changed, or carbon tax, this is called. It computes c02 cost
// If explicit change,  do nothing (note, an alert is included in the element to suggest not explicitily setting this)
function computeGasCO2Cost(thisElement,changedElement) {
  var v1,v2,v3,v4,v1a;

  if (thisElement==changedElement) return {status:"ok"} ;   // self change, alert done via alert atrribute. So just accept it
  var boo=get_elemNumber(thisElement,'');  // is it blank (if so, default is to compute

// v1 and v2 should be legit numbers
  v1=get_elemNumber('co2PerGallon',0);      //   pounds per gallon
  v1a=v1/2000;                             // tons per gallong
  v2=get_elemNumber('carbonPrice',0);   // price per ton

  v3=v1a*v2 ;
  v4=v3  ;
  return v4 ;
}


//===============================
//  if co2 per gallon field is changed, or carbon tax, this is called. It computes c02 cost
// If explicit change,  do nothing (note, an alert is included in the element to suggest not explicitily setting this)
function computeKwhCO2Cost(thisElement,changedElement) {
  var v1,v2,v3,v4,v1a;

  if (thisElement==changedElement) return {status:"ok"} ;
  var boo=get_elemNumber(thisElement,'');  // is it blank (if so, default is to compute

// v1 and v2 should be legit numbers
  v1=get_elemNumber('co2PerKwh',0);      //   pounds per gallon
  v1a=v1/2000;                             // tons per gallong
  v2=get_elemNumber('carbonPrice',0);   // price per ton
  v3=v1a*v2 ;

  return v3 ;

}



//==============
// compute short trip miles
function computeShortMiles(thisElement,changedElement,icall) {
var v1a,v1b,v2a,v2b,v1ab,v2ab,vall;
  if (thisElement==changedElement) {
     v1a=get_elemNumber(thisElement,'error','blankok ');
     if (trim(v1a)=='error') { return {status:'nosave'} };   // should NEVER happen (nan's caught by checkNumber
     if (v1a!=='') {
        alert('Warning: instead of a value of '+v1a+', we recommend using the worksheet to compute short trip miles -- it has a few variables needed for electric car computations. \n Hint: to recalculate using worksheet values, enter a space in the short-trip-miles input box. ');
        return {status:'ok'} ;
     }
  }
// here if blank

   v1a=get_elemValue('workDayDistance',0,'F');
   v1b=get_elemValue('nWorkDays',0,'F');
   v1ab=v1a*v1b;

   v2a=get_elemValue('weekendDistance',0,'F');
   v2b=get_elemValue('nWeekendDays',0,'F');
   v2ab=v2a*v2b;

   vall=v1ab+v2ab;
   return vall;
}



//==========================
// autofill maintenance values for nyears years. Using mileage of car at that year

function autoFillMaint(thisElement,changedElement,icall,alist,origId) {
  var igroup,nyears,dvals,iset,iy,cumMiles,rmult,insur,repairs,totmm,toname;
  var milesPerYear;
  var dvals,cumMaint=0,avgMaint;

  var  seps=[36000,60000,100000,150000] ;

  nyears=get_elemNumber('nYears',10,'INT');
  igroup=readAttribute(thisElement,'group',0);
  dvals=updateYearlyMiles(igroup,nyears);
  milesPerYear=readUpdateWatch('milesPerYear',0);

  for (iy=1;iy<dvals.length;iy++) {
    iset=5;
    cumMiles=dvals[iy];
    for (im=0;im<seps.length;im++) {
       if (cumMiles<seps[im]) {
            iset=im+1; break;
       }
    }

    rmult=get_elemNumber('repair'+iset,0);
    insur=get_elemNumber('insurance'+iset,0);
    repairs=rmult*milesPerYear ;
    totmm=insur+repairs;
    toname='maint'+iy+'_'+igroup;
    update_elemValue(toname,totmm.toFixed(0),totmm);       // the input element

    cumMaint=cumMaint+totmm;

  }

  return {status:'nosave'} ;
}


//=------------------
// compute yearly mileage for car igroup, or yearly miles
//  elements/updates saved to:
//  ALL :  shortTripMiles, longTripMiles, milesPerYear, yrMilesI_n
//  BASICONLY: shortTripMiles, longTripMiles, milesPerYear,
//  CAR :   yrMilesI_n

function updateYearlyMiles(igroup,nyears,valsOnly,atype) {

  var startMileage,shortTripMiles,longTripMiles,milesPerYear,iy,cumMiles,dvals=[],nyears ;
  if (arguments.length<3) valsOnly=0;
  if (arguments.length<4) atype='ALL';

  if (atype=='ALL' || atype=='BASICONLY') {                                                // milesPerYear does NOT depend on car
     shortTripMiles=get_elemNumber('shortTripMiles',0);   saveUpdateWatch('shortTripMiles',shortTripMiles);
     longTripMiles=get_elemNumber('longTripMiles',0);   saveUpdateWatch('longTripMiles',longTripMiles) ;
     milesPerYear=longTripMiles+shortTripMiles ;          saveUpdateWatch('milesPerYear',milesPerYear) ;
     if (atype=='BASICONLY') return milesPerYear ;
  }
  if (atype=='CAR') {
     milesPerYear=readUpdateWatch('milesPerYear',0);
  }

  startMileage=get_elemNumber('carMileage_'+igroup,0);


// compute mileage over course of a year, using start-of-year-mileage
  for (iy=1;iy<=nyears;iy++) {
      cumMiles=startMileage+ ((iy-0.5)*milesPerYear) ;  // mid year miles
      dvals[iy]=cumMiles;
      if (valsOnly!==1) {
         toname='yrMiles'+iy+'_'+igroup;
         try {
             update_elemValue(toname,cumMiles.toFixed(-2),cumMiles);     //the info element
         }
         catch(err) {
             update_elemValue(toname,cumMiles.toFixed(0),cumMiles);     //the info element
         }
      }
   }
   return dvals ;
}




//============================
// fix the short trip distribution (so the expected value, over reference values, is 100; and probs add to 100)
// save results to 'updates', and to info elements. If argument of 1, also save to input element (and their corresponding 'updates')
// also, save results to stDistros global

// Thus, if argument of 0 (say, when one of the values  is changed), the  distribution  displayed in the info elements are updated,
//  BUT not what it displayed in the input boxes
// This means that the input boxes and the info elements won't match whilst changes are being made. Once the 'calibrate" button is pushed, they will
// line up!  Why do it this way? It would be a major pain to enter values if calibration kept happening!
//
//  example: stDistros should have weights of: 15,33,66,100,133,166,200
//  input elements are named:  stDistro_nnn (nnn one of the above weights; i.e.; 15,33,...,200)
//  info elements are named: stDistro_nnn_cal
//  per usual, 'updates' field are exactly same as input element ids
//  returns status:nosave; and  sets globals in stDistros (.probs and .weights)  -- both of them arrays

function updateStDistro(thisElement,changedElement,icall,plist,origId) {

var updateIt,alist,is100,cids,weights,probs,jfids,jfidIds,wasweight,cidIds,asum,cid,cidId,jfidId,jfid,aweight,aval;
var probs,asum,z,z2,tmp,psum,pvals,ii;

if (changedElement=='0') return {status:'nosave'} ;
if (arguments.length<4) plist=[icall];   // a hack to deal with calls by  figValues

updateIt='0';
if (plist.length>0 && trim(plist[0])=='1')  updateIt='1';   // do NOT update input elements with "calibrated" values
  is100=0;
  cids=[]; weights=[]; probs=[]; jfids=[];jfidIds=[]; wasweight=-1; cidIds=[];
  asum=0;

  alist=document.getElementsByName('stDistros');

  for (ii=0;ii<alist.length;ii++){              // get sum of probabilities
      cid=alist[ii];                            // the input element node
      cidId=cid.id;                            // input element's ID
      jfidId=cidId+'_cal';                    // the "calibrated" span's ID
      jfid=document.getElementById(jfidId);   // calibrated span's node

      if (!jfid) abortJavaScript('Error in fixStDistro: no _cal info field to go with input element of '+cidId);

      aweight=parseFloat(readAttributeNode(cid,'refValue',0));    // hard coded weight
      if (isNaN(aweight)|| aweight<=wasweight || aweight<0 ) {                                            // should NEVer happen
         abortJavaScript('Error: missing, or non-increasing, refvalue ('+aweight+' vs '+wasweight+') in short trip distributions ');
      }
      aval=get_elemNumber(cid,0);            // prob enetered for this weight
      if (aweight==100) is100=ii ;           // center weight (i.e.; 100%)
      wasweight=aweight;
      jfids.push(jfid); cids.push(cid); jfidIds.push(jfidId); cidIds.push(cidId);
      probs.push(aval); weights.push(aweight);   // probs is the "entered pctabilities", weights is the "hard coded" percentage (the weight)
      asum=asum+ aval ;                          // prob sum (will be normalized to sum to 100)
  }

  if (is100<0)   abortJavaScript('Error: you must have one of the short trip distibutions refValues equal to 100 ');

// if here, form setup  & values okay

  if (asum==0)  {               // empty or all 0 probs: use a point mass at 100
    for (ii=0;ii<probs.length;ii++) {
       cidId=cidIds[ii]; jfidId=jfidIds[ii];
       tmp=0; if (ii==is100) tmp=100;
       probs[ii]=tmp;
    }
  }

// take these references and their probablities and create an "empirical" pdf defined over integers (say, between 15 and 200)

  z=makeEmpiricalPdf(weights[0],weights[weights.length-1],weights,probs);   // fill in a distribution from these "sampled" points
  z2=changeMeanPdf(z,100);                                             // make sure it is centered at 100
// now extract and save to stDistros
   stDistro.weights=[];             // reset globals
   stDistro.probs=[];
   psum=0; pvals=[];
   for (ii=0;ii<weights.length;ii++) {                //get sum used for calibration
       aweight=weights[ii];
       tmp=figPdfValue(aweight,z2) ;
       psum=psum+tmp ;
       pvals[ii]=tmp;
   }

   for (ii=0;ii<weights.length;ii++) {                // reset values (calibrate!)
       cidId=cidIds[ii]; jfidId=jfidIds[ii];
       tmp=1/weights.length ;                                        // hack if psum=0;l
       if (psum!==0) tmp=100*pvals[ii]/psum;
       update_elemValue(jfidId,tmp.toFixed(0),tmp);
       if (updateIt=='1')  update_elemValue(cidId,tmp.toFixed(0),tmp);
       stDistro.weights[ii]=aweight;
       stDistro.probs[ii]=tmp;
   }


   histoPdf('showHisto1',z2,' clear=1 height=30 width=3 meancolor=lime ',[15,33,66,100,133,166,200]);

   stDistro.pdfObj=z2 ;
   return {status:'nosave'};  // probs and weights used by up

}

//===============================
// conmpute distribution of short trips (as a weighet-sum type of empirical pdf object
// stDistro.pdfObj must exist (if not, nothing is shown
// if shortTripMiles not set, note it
// compute a histogram of short trips miles per day, using work/weekend info and stDistro
// if useId is specifed (an id of a div), histogram writted to it
function updateStTripDistro(shortTripMiles,useId) {

if (arguments.length<2) useId='';
shortTripMiles=parseInt(shortTripMiles);

if (shortTripMiles==0) {
  ifoo=document.getElementById(useId);
  ifoo.innerHTML='<b>You haven\'t entered (directly, or using the above worksheet) your yearly short-trip mileage</b>';
  return  0 ;
}

if (typeof(stDistro.pdfObj)=='undefined') {
  ifoo.innerHTML='<b>ERROR: updateSTDistro was not called prior to calliing updateStTripDistro </b>';
  return 0;
}
apdfObj=stDistro.pdfObj ;

workDayDistance=get_elemNumber('workDayDistance',0);
nWorkDays=get_elemNumber('nWorkDays',0) ;
weekendDistance=get_elemNumber('weekendDistance',0) ;
nWeekendDays=get_elemNumber('nWeekendDays',0)
if (workDayDistance==0 && weekendDistance==0)  {                            // no info, use overall average
    weekendDistance=shortTripMiles/360 ; nWorkDays=0 ; nWeekendDays=360 ;
} else {                                 // got specifics, make sure they do not contract yearly short trip distance (if so, adjust so they do)
    tmp1=(workDayDistance*nWorkDays)+(weekendDistance*nWeekendDays); tmp1=tmp1.toFixed(0);
    tmpShort=shortTripMiles ;
    adj=tmpShort/tmp1;
    workDayDistance=workDayDistance*adj ; weekendDistance=weekendDistance*adj ;
//    if (adj.toFixed(2)!==1.00) {
//       update_elemValue('workDayDistance',workDayDistance.toFixed(1)); update_elemValue('weekendDistance',weekendDistance.toFixed(1));  // force 'em to be equal(shortTripMiles is assumed to be correct)
//    }

}
smin=apdfObj.min ;  smax=apdfObj.max ;
pdfObjs=[]; weights=[];
if (workDayDistance>0) {
  tripMin=parseInt(smin*workDayDistance/100) ;
  tripMax=parseInt(smax*workDayDistance/100) ;
  bPdf=changeRangePdf(apdfObj,tripMin,tripMax);
  bPdf=changeMeanPdf(bPdf,workDayDistance);
  pdfObjs.push(bPdf); weights.push(nWorkDays);
}
if (weekendDistance>0) {
  tripMin=parseInt(smin*weekendDistance/100) ;
  tripMax=parseInt(smax*weekendDistance/100) ;
  bPdf=changeRangePdf(apdfObj,tripMin,tripMax);
  bPdf=changeMeanPdf(bPdf,weekendDistance);
  pdfObjs.push(bPdf); weights.push(nWeekendDays);
}
stDistro.tripDists=weightedSumPdf(pdfObjs,weights,0);

if (useId!=='')  histoPdf(useId,stDistro.tripDists,' clear=1 height=50 width=3 meancolor=lime ',['5%','25%','50%','75%','95%'],[33,100]);

return 1;


}


//=======================================         pct  weight
// compute lots of values, given change in general or specific parameters
// if general paramter; change value for ALL cars
// if group attribute available: change value just for specific car (group)
// isSpecific: 1 if specific, 0 if general DEPRECATED
// If called by function (not a watchCall: figValues(2,igroup)   (igroup=0 for general changes)

function figValues(thisElement,changedElement,icall,alist,origId,cElem) {

if (origId==0) return {status:"nosave"} ;

var isSpecific,igroup,nyears,ncars,n1,n2,vv,avgDist,icar,dvals,cartype,astat,cumMaint,avgMaint,m,interestRate,yrcost2;
var mileYears,currentValue,depreciateRate,adj,endValue;
var pprice,pweight,gp,galPrLb,buildCost,totCost,yrMaints=[];
var discountedGCosts,fuelcost,intRate,yrcost,discountedNCosts ,discountedYCosts;
var shortTripMiles,workDayDistance,nWorkDays,weekendDistance,nWeekendDays,smin,smax,tmpShort,tmp1;
var m,apdfObj,adj;
var pdfObjs,weights,smin,smax,tripMin,tripMax,bPdf ;



if (thisElement!==2) {
   igroup=readAttribute(thisElement,'group',0);  // the group number set in the "catch changes" element (the one that watches for any change). Will be 0 if a generalChange catcher
//decpreacated   isSpecific=0     ;  if (alist.length>0) isSpecific=trim(alist[0]);
} else {
   igroup=changedElement ;
}
 nyears=get_elemNumber('nYears',10,'INT');
 ncars=get_elemNumber('nCars',1,'INT');

// general change: update ALL cars. Specific change, just update this car  (note: thisElement of catchGeneral vs catchSpecific could also be used
if (igroup==0) {
   n1=1 ;
   n2=ncars;
} else {
   n1=igroup ;
   n2=igroup
}

shortTripMiles=readUpdateWatch('shortTripMiles',0);
// calibrate trip distribution stuff
updateStDistro(1,1);                 // update stDistro (probably not necessary, but wth
updateStTripDistro(shortTripMiles,'showHisto2');        // the distribution of short trips: # of days with trip distance of m

avgDist=updateYearlyMiles(icar,nyears,1,'BASICONLY') ;        // setup, used in the car specific stuff in the for loop

for (icar=n1;icar<=n2;icar++) {
   dvals=updateYearlyMiles(icar,nyears,0,'CAR') ;       // update the distance measures (below the maint input boxes) -- the "last year" mileage is used to compute end of horizon depreciated value
   cartype=get_elemValue('carType_'+icar,1);
   astat=computeYearlyCosts(icar,cartype,shortTripMiles) ;
   cumMaint=0;
   for (m=1;m<=nyears;m++) {
      yrMaints[m]= get_elemNumber('maint'+m+'_'+icar,0) ;
      cumMaint=cumMaint+  yrMaints[m] ;
   }
   avgMaint=cumMaint/nyears;
   saveUpdateWatch('yearlyMaintCost',avgMaint,icar);

// end value (depreciated)
 mileYears=dvals[dvals.length-1]/10000;
 currentValue=get_elemNumber('currentValue_'+icar,0);
 depreciateRate=get_elemNumber('depreciation_'+icar,0)/100;
 adj=Math.exp(-mileYears*depreciateRate);
 endValue=currentValue*adj;
 saveUpdateWatch('endValue',endValue,icar);


// acqusition cost
  pprice=get_elemNumber('carPrice_'+icar,0);
  pweight=get_elemNumber('carWeight_'+icar,0);
  gp=get_elemNumber("fullGasPrice",0);
  galPerLb=get_elemNumber('gallonsPerLbNormal',0);
  if (cartype!=='1' )  galPerLb=get_elemNumber('gallonsPerLbHybrid',0);
  buildCost=gp*(galPerLb*pweight);
  totCost=pprice + buildCost ;
  saveUpdateWatch('totalPrice',totCost,icar);

// discounted cost of ownership
 interestRate= get_elemNumber('iRate',0.04);
 fuelCost=readUpdateWatch('yearlyFuelCost',0,icar);
 discountedGCosts=totCost;
 discountedYCosts=0;
 for (m=1;m<=nyears;m++) {
    yrcost=fuelCost+yrMaints[m];
    yrcost2=  (yrcost*Math.exp(-interestRate*m)) ;
    discountedYCosts=discountedYCosts+yrcost2;;
    discountedGCosts=discountedGCosts+yrcost2;
 }
 discountedNCosts=discountedGCosts- (endValue*Math.exp(-nyears*interestRate)) ;

 saveUpdateWatch('discountedYCosts',discountedYCosts,icar);
 saveUpdateWatch('discountedGCosts',discountedGCosts,icar);
 saveUpdateWatch('discountedNCosts',discountedNCosts,icar);
}

return {status:"nosave"} ;
}

                          // thisEle changedEl
//=============
// called by figValues: compute several yearly costs variables (for display in INFO elements)
// you must call updateYearlyMiles beforehand, updateStDistros, and updateStTripDistro

function computeYearlyCosts(icar,cartype,shortTripMiles) {

var evResults,evMiles,longTripMiles,allGasMiles,stGallons,stGallonsCost,ltGallons,ltGallonsCost,averageMpg,yearlyGasCost;
var totFuelCost,gp,stmpg,ltmpg,gasStMiles,avgGasCostPerMile,totFuelCost,afail;

//  EV useage

   evResults=estEVuseage(icar,cartype,shortTripMiles) ;   // update EV   info elements
   evMiles=evResults.evMiles ;

//   Average miles per gallon
   longTripMiles=readUpdateWatch('longTripMiles',0);
   allmiles=parseInt(shortTripMiles)+parseInt(longTripMiles);

   allGasMiles=0;
   stGallons=0; stGallonsCost=0; ltGallons=0;ltGallonsCost=0;  averageMpg=0; yearlyGasCost=0;
   totFuelCost=readUpdateWatch('yearlyKwhCost',0,icar);

   if (cartype!=='4' && allmiles>0) {                                  // all electric: no gas usee so skip
      gp=get_elemNumber("fullGasPrice",0);
      stmpg=get_elemNumber("stMPG_"+icar,0)
      ltmpg=get_elemNumber("ltMPG_"+icar,0)

      if (stmpg>0 || ltmpg>0)  {
          gasStMiles=shortTripMiles-evMiles ;
          allGasMiles=gasStMiles + longTripMiles ;
          stGallons=gasStMiles/stmpg; ltGallons=longTripMiles/ltmpg;
          stGallonsCost=gp*stGallons  ;ltGallonsCost=gp*ltGallons;
          yearlyGasCost=stGallonsCost+ltGallonsCost ;
          averageMpg= (stmpg*gasStMiles/allGasMiles) +  (ltmpg*longTripMiles/allGasMiles);
          avgGasCostPerMile=gp/averageMpg ;
      }
   }
    totFuelCost=readUpdateWatch('yearlyKwhCost',0,icar)+yearlyGasCost;

    saveUpdateWatch('stGal',stGallons,icar);
    saveUpdateWatch('stGalCost',stGallonsCost,icar);
    saveUpdateWatch('ltGal',ltGallons,icar);
    saveUpdateWatch('ltGalCost',ltGallonsCost,icar);
    saveUpdateWatch('yearlyGasCost',yearlyGasCost,icar);
    saveUpdateWatch('averageMPG',averageMpg,icar);
    saveUpdateWatch('totalYearlyMiles',allmiles,icar);
    saveUpdateWatch('yearlyFuelCost',totFuelCost,icar);
    saveUpdateWatch('avgGasCostPerMile',avgGasCostPerMile,icar);


   if (cartype=='4')  {                                 // all ev
       afail=longTripMiles+ (shortTripMiles-evMiles);
//         alert('a car evran '+afail);
         saveUpdateWatch('yearlyEVrangeFailure',afail,icar);
    }

    return 1;
}


//=========================== avgPerMi
// called by computeYearlyCosts: estimate ev useage, save to updates
// uses stDistr.tripDists ( created by updateStTripDistro
// params to use:  fullKwhPrice  EVRange_*       mpKwh_*
//  info fields to update: evMiles_*    evMilesPct_*    stKWH_*     stKWHCost_*     yearlyKwhCost_*

function estEVuseage(igroup,cartype,shortTripMiles) {

var kwhCost,kwhUsed,kwhCostMile,evMilesPct,gasmiles,evMiles,afrac,totmiles,amiles,im,evrange,evdays,fullKwhPrice,evrange,mpKwh,apdf,amin,amax;

evrange=get_elemNumber('EVRange_'+igroup,0);
mpKwh=get_elemNumber('mpKwh_'+igroup,0);

if (cartype=='2' || cartype=='1' || evrange==0 || shortTripMiles==0 || mpKwh==0) {         // no electric capacity (or only) then 0 for all EV fields
   saveUpdateWatch('evMiles',0,igroup)  ;
   saveUpdateWatch('evMilesPct',0,igroup);
   saveUpdateWatch('stKWH',0,igroup);
   saveUpdateWatch('stKWHCost',0,igroup);
   saveUpdateWatch('yearlyKwhCost',0,igroup);
   saveUpdateWatch('stKWHCostPerMile',0,igroup);
   return  {evMiles:0,yearlyKwhCost:0,evMilesPct:0,stKWH:0,stKWHCost:0,stKWHCostPerMile:0} ;
}

fullKwhPrice=get_elemNumber('fullKwhPrice',0) ;

// count number of "days" in stDistro.tripDists.pdf from  min to evrange;
apdf=stDistro.tripDists.pdf ; amin=stDistro.tripDists.min; amax=stDistro.tripDists.max;
evdays=0; evMiles=0; totmiles=0;
for (var im=amin;im<=amax;im++) {
   amiles=(apdf[im]*im);
   totmiles=totmiles+amiles;
   if (im<=evrange) {
        evMiles=evMiles+ amiles;
        evdays=evdays+apdf[im];
   }
}
afrac=shortTripMiles/totmiles;
evMiles=evMiles*afrac ;        //  normalize (so that sum is shortTripMiles)
gasmiles=shortTripMiles-evMiles;
evMilesPct=evMiles/shortTripMiles ;

// seperately for work and weekend: create empirical pdf from minPct * xxDistance
kwhUsed=0; kwhCost=0;
if (mpKwh>0) {
   kwhCostMile=fullKwhPrice/mpKwh;
   kwhUsed=evMiles/mpKwh ;
   kwhCost=kwhUsed* fullKwhPrice
}

saveUpdateWatch('evMiles',evMiles,igroup)  ;
saveUpdateWatch('evMilesPct',evMilesPct,igroup);
saveUpdateWatch('stKWH',kwhUsed,igroup);
saveUpdateWatch('stKWHCost',kwhCost,igroup);
saveUpdateWatch('yearlyKwhCost',kwhCost,igroup);
saveUpdateWatch('stKWHCostPerMile',kwhCostMile,igroup);

return  {evMiles:evMiles,yearlyKwhCost:kwhCost,evMilesPct:evMilesPct,stKWH:kwhUsed,stKWHCost:kwhCost,stKWHCostPerMile:kwhCostMile} ;

}

//================================
// create a collection
function makeCollection(thisElement,changedElement,icall,alist,origId,cElem) {

//if (thisElement=='createColl_3')

var igroup,ncars,idone,im,arf,igoo,acar,ii,cars=[],im1;
var mm,ib,aname,clooks=[];

var bname,sttot,lttot,stpct,ltpct,ado;
var  shortTripMiles,longTripMiles,interestRate,fullGasPrice,fullKwhPrice,nyears,gasStMiles;
var ithCar,startMileages,yrmiles,zmiles,zmaint,iyr,foo,tval,totmaint;
var stMiles,ltMiles,gasStMiles,allmiles,allGasMiles,allGallons;

var  all_stgal,all_stgalcost,all_ltgal,all_ltgalcost,all_evmiles,all_stkwh,all_stkwhcost,all_avgMpg,all_avgMpk;
var  all_totalPrice, all_totalMilesPerYear, all_yearlyEVrangeFailure,all_yearlyGasCost,all_yearlyFuelCost,all_avgMaintCost,all_endValue;
var all_discountedNCosts,all_discountedYCosts,all_discountedGCosts,disc1,yrcost,yrcost2,all_yearlyGasCost,carType ;


  if (origId==0)   return {status:"nosave"};
  ncars=get_elemNumber('nCars',1,'INT');

  igroup=readAttribute(thisElement,'group',0);


  isCar=get_elemValue('isCar_'+igroup,0);
//       document.getElementById('debugOutput').innerHTML+='<br>in mm '+thisElement+' iscar ='+isCar;
  if (isCar=='1')           return {status:"nosave"};   // a car, so don't do this (useful on broad updates)

// 1) Retrieve and check specs for this collection
// 1.a -- names correct?
  idone=0;
  for (im=1;im<=3;im++) {
      arf='collCar'+im+'_'+igroup ;
      igoo=document.getElementById(arf);

      acar=trim(get_elemValue(arf,''));
      if (idone==1 && trim(acar)!=='') {
             alert('You specified a car name AFTER an empty car name field. Please reenter ');
             return {status:"nosave"};
      }

      if (trim(acar)=='') {
          idone=1;
          continue;
      }

// 1.b1) extract specs of this collection
      ii=cars.length;
      cars[ii]={};
      cars[ii].name=get_elemValue('collCar'+im+'_'+igroup,'');
      cars[ii].stPct=get_elemValue('collST'+im+'_'+igroup,'');
      cars[ii].ltPct=get_elemValue('collLT'+im+'_'+igroup,'');
      if (cars[ii].ltPct==0 && cars[ii].stPct==0) {
          if (origid!='1')    alert('You specified a car ('+acar+' with zero %LT and %ST. Please specify at least one non-zero value.' );  // don't do this if a parameter restore
          return {status:"nosave"};
      }

  }                // im

// 1.b2 get list of current cars

  for (var mm=1;mm<=igroup-1;mm++) {                    // only use cars specified before this
      ib=get_elemValue('isCar_'+mm,1);
      if (ib==0) continue ;                              // a collection, so skip
      aname=get_elemValue('carName_'+mm,'');
      aname=trim(aname.toUpperCase());
      if (aname=='') continue ;             // ignore if no name
      clooks[aname]=mm;
  }

// 1.b3  check validity of cars specified in collection  (does a car name exist?)
  for (im=0;im<cars.length;im++) {

        bname=trim(cars[im].name.toUpperCase());
        if (typeof(clooks[bname])=='undefined') {
            alert('Sorry, you entered a car ('+cars[im].name+') that has not been specified. Please correct. ('+thisElement+','+changedElement);
            return {status:"nosave"};
        }
        cars[im].which=clooks[bname];
  }

// 1.d  normalize st and lt pcts
  sttot=0; lttot=0;
  for (im=0;im<cars.length;im++) {
      stpct=parseInt(cars[im].stPct) ; sttot=sttot+stpct;
      ltpct=parseInt(cars[im].ltPct) ; lttot=lttot+ltpct;
  }

  if (lttot==0 || sttot==0) {
         im1=im+1;
        if (origId!='1')    alert(' Sorry, for collection '+thisElement+', car '+acar+', you did not enter any %ST (percent short trip) or %LT (percent long trip) values ');
        return {status:"nosave"};
  }

  for (im=0;im<cars.length;im++) {
      im2=im+1;
      cars[im].stPct=cars[im].stPct/sttot; update_elemValue('collST'+im2+'_'+igroup, parseInt(100* cars[im].stPct)) ;
      cars[im].ltPct=cars[im].ltPct/lttot; update_elemValue('collLT'+im2+'_'+igroup, parseInt(100*  cars[im].ltPct)) ;
  }

// 2) if here, entry is okay. Calculate some stuff


//  turnDisplayOn("collectionInfo_"+igroup);   -- use checkbox on page to hide details

// 2.a : get some general params
  shortTripMiles=get_elemNumber('shortTripMiles',0);                   // some general variables
  longTripMiles=get_elemNumber('longTripMiles',0);
  allmiles=shortTripMiles+longTripMiles;
  nyears=get_elemNumber('nYears',10,'INT');
  interestRate= get_elemNumber('iRate',0.04);
  fullGasPrice= get_elemNumber('fullGasPrice',0);
  fullKwhPrice= get_elemNumber('fullKwhPrice',0);

// 2.b   calculate yearly mileage, and maintenance  for each car in collection
  for (im=0;im<cars.length;im++) {
      stpct=cars[im].stPct ;
      ltpct=cars[im].ltPct ;
      ithCar=cars[im].which;
      startMileage=get_elemNumber('carMileage_'+ithCar,0);
      yrmiles=((stpct)*shortTripMiles)+ ( (ltpct)*longTripMiles) ;  // total miles driven in this car
      zmiles=[];  zmaint=[];
// 2.b.i : calculuate odometer readings for each year
      for (iyr=1;iyr<=nyears;iyr++) {
         foo='yrMiles'+iyr+'_'+ithCar;
         tval=get_elemNumber(foo,0) ;
         zmiles[iyr]=startMileage+( (iyr-0.5)*yrmiles);    // odometer reading mid year
      }

// 2.b.ii: auto-compute approximate maintenance (based on year with closest miles, compared to insurance & repairs general params
      zmaint=figYearlyMaint(zmiles,yrmiles) ;       // note: figYearlYmaint overwrites customized "yearly maintenace for collection".  Thus, people will have to re-enter customization
      totmaint=0;
      for (iyr=1;iyr<=nyears;iyr++) totmaint=totmaint+zmaint[iyr];

// 2.b.iii  : save some car specific stuff
      cars[im].startMiles=startMileage ;
      cars[im].zmiles=zmiles;
        cars[im].endMiles10k=zmiles[zmiles.length-1]/10000;
        cars[im].endMiles=zmiles[zmiles.length-1] ;
        cars[im].milesDriven= cars[im].endMiles -  cars[im].startMiles ;

      cars[im].zmaint=zmaint;
      cars[im].avgmaint=totmaint/nyears;
      cars[im].stMPG=get_elemNumber('stMPG_'+ithCar,0);
      cars[im].ltMPG=get_elemNumber('ltMPG_'+ithCar,0);

      cars[im].mpKwh=get_elemNumber('mpKwh_'+ithCar,0);
      cars[im].evmiles=get_elemNumber('evMiles_'+ithCar,0) ;

      cars[im].carType=get_elemNumber('carType_'+ithCar,0) ;
      cars[im].EVrangeFailure=0;
      if (cars[im].carType==4) {
          cars[im].EVrangeFailure=readUpdateWatch('yearlyEVrangeFailure',0,ithCar);
//          get_elemNumber('yearlyEVrangeFailure_'+ithCar,0);
//        alert(' evang '+im+' = '+    cars[im].EVrangeFailure);
      }
      cars[im].currentValue=get_elemNumber('currentValue_'+ithCar,0);
      cars[im].depreciateRate=get_elemNumber('depreciation_'+ithCar,0)/100;
      cars[im].totalPrice=get_elemNumber('totalPrice_'+ithCar,0)
      cars[im].stGal=get_elemNumber('stGal_'+ithCar,0);
      cars[im].ltGal=get_elemNumber('ltGal_'+ithCar,0);
  }

// 3. across cars in the collection, compute some weighted aggregate stats

//3.1 : intializse
  all_stgal=0; all_stgalcost=0;  all_ltgal=0; all_ltgalcost=0;
  all_evmiles=0; all_stkwh=0; all_stkwhcost=0;

  all_totalPrice=0;  all_totalMilesPerYear=0; all_yearlyEVrangeFailure=0;
  all_yearlyGasCost=0;    all_yearlyFuelCost=0;
  all_avgMaintCost=0;  all_endValue=0; all_avgMpg=0; all_avgMpk=0;
  yearlyGas=[]; yearlyKwh=[]; yearlyMaint=[]; yearlyMiles=[]; endValues=[];   allGasMiles=0; allGallons=0;
  for (m=1;m<=nyears;m++) {   yearlyGas[m]=0; yearlyKwh[m]=0; yearlyMaint[m]=0 ;yearlyMiles[m]=0;   };   // intialize to 0

//3.ii : compute weighted sums
  for (im=0;im<cars.length;im++) {
      im1=im+1;
      turnDisplayOn("breakDown"+im1+"_"+igroup);

      stpct=cars[im].stPct  ;
      ltpct=cars[im].ltPct  ;
      evmiles=cars[im].evmiles*stpct ;   // evmiles is complicated, so just use stPct fraction  of car-specific total
      stMiles=shortTripMiles*stpct ;
      gasStMiles=stMiles-evmiles ;
      ltMiles=longTripMiles*ltpct ;

      allGasMiles=allGasMiles+ltMiles+gasStMiles  ;

//3.ii.a : gallons and kwh
       stgal=0; ltgal=0;
       if (cars[im].stMPG>0)  stgal=(gasStMiles/cars[im].stMPG);
       if (cars[im].ltMPG>0)  ltgal=(ltMiles/cars[im].ltMPG) ;
      all_stgal=stgal + all_stgal ;
      all_ltgal=ltgal + all_ltgal ;
         evmiles=cars[im].evmiles*stpct ;   // evmiles is complicated, so just use stPct fraction  of car-specific total
         stkwh=0;
         if (cars[im].mpKwh>0)  stkwh=(evmiles/cars[im].mpKwh) ;

      allGallons=allGallons+stgal+ltgal ;

      all_evmiles=evmiles + all_evmiles ;
      all_stkwh=stkwh + all_stkwh;

      all_yearlyEVrangeFailure=cars[im].EVrangeFailure*stpct + all_yearlyEVrangeFailure;  // evrange failure is complicated, so ...

      all_totalPrice=cars[im].totalPrice + all_totalPrice ;                // no weighting (acquisition cost does not depend on future useage)
      all_avgMaintCost=cars[im].avgmaint+all_avgMaintCost ;         // no weighting (maintenance computed using miles driven/ miles on car

// 3.ii.b:  value of car at end of time (depreciation applied)
         adj=Math.exp(-cars[im].endMiles10k*cars[im].depreciateRate) ;
         aval=cars[im].currentValue ;
         aval2=adj*aval;

      endValues[im]=aval2;
      all_endValue=all_endValue+(aval2);

//// 3.ii.c: these are used to computed  discounted costs   : note that same values used in each year (no adjustment of car useage over time)
     for (m=1;m<=nyears;m++) {
             yearlyGas[m]=yearlyGas[m]+stgal+ltgal;
             yearlyKwh[m]=yearlyKwh[m]+stkwh ;
             yearlyMaint[m]=yearlyMaint[m]+cars[im].zmaint[m];
             yearlyMiles[m]=yearlyMiles[m]+cars[im].zmiles[m];
     }

   }                                                   // im

//4.a : more aggregate status
   all_totalMilesPerYear=shortTripMiles+longTripMiles ;
   all_ltgalcost=all_ltgal*fullGasPrice ;
   all_stgalcost=all_stgal*fullGasPrice ;
   all_yearlyGasCost=all_ltgalcost+ all_stgalcost  ;
   all_stkwhcost=all_stkwh*fullKwhPrice;
   all_yearlyFuelCost=all_yearlyGasCost+all_stkwhcost ;

  if (allGallons>0)  all_avgMpg=allGasMiles/allGallons ;
  if (all_stkwh>0)  all_avgMpk=all_evmiles/all_stkwh ;

  all_discountedGCosts=all_totalPrice      ;               // start with acquistion costs
  all_discountedYCosts=0;
  for (m=1;m<=nyears;m++) {                                // add discounted costs of running car
     yrcost=(yearlyGas[m]*fullGasPrice) + (yearlyKwh[m]*fullKwhPrice) + yearlyMaint[m];
     yrcost2=(yrcost*Math.exp(-interestRate*m)) ;
     all_discountedGCosts=all_discountedGCosts+yrcost2;
     all_discountedYCosts=all_discountedYCosts+yrcost2;
  }
  adj=Math.exp(-nyears*interestRate)     ;
  disc1=adj*all_endValue;
  all_discountedNCosts=all_discountedGCosts+ - disc1 ;      // subtract discounted value of depreciated car

//4.b : compute discounted costs

// 4. Record to screen
// 4.a : mzintenance costs
 for (iyr=1;iyr<=nyears;iyr++) {                     // sum of maintenance & mileage   (for this car in this collection)

    ado='Cmaint'+iyr;    saveUpdateWatch(ado,yearlyMaint[iyr],igroup);
    ado='CyrMiles'+iyr;    saveUpdateWatch(ado,yearlyMiles[iyr],igroup);

    for (im=0;im<cars.length;im++) {
       ithCar=cars[im].which;
       saveUpdateWatch('Car'+ithCar+'Maint'+iyr,cars[im].zmaint[iyr],igroup);     // car-by-car breakdown
       saveUpdateWatch('Car'+ithCar+'YrMiles'+iyr,cars[im].zmiles[iyr],igroup);
    }
  }


// 4.b  total battery miles, kwh used for st, cost of kwh, total st gallons and st cost, lt gallons and  lt cost
   saveUpdateWatch('CstGal',all_stgal,igroup);
   saveUpdateWatch('CstGalCost',all_stgalcost,igroup);
   saveUpdateWatch('CltGal',all_ltgal,igroup);
   saveUpdateWatch('CltGalCost',all_ltgalcost,igroup);
   saveUpdateWatch('CevMiles',all_evmiles,igroup);
   saveUpdateWatch('CstKWH',all_stkwh,igroup);
   saveUpdateWatch('CstKWHCost',all_stkwhcost,igroup);
   saveUpdateWatch('CaverageMPG',all_avgMpg,igroup);
   saveUpdateWatch('CaverageMPK',all_avgMpk,igroup);

   saveUpdateWatch('CtotalPrice',all_totalPrice,igroup);
   saveUpdateWatch('CtotalYearlyMiles',all_totalMilesPerYear,igroup);

   saveUpdateWatch('CyearlyEVrangeFailure',all_yearlyEVrangeFailure,igroup);
   saveUpdateWatch('CyearlyGasCost',all_yearlyGasCost,igroup);
   saveUpdateWatch('CyearlyKwhCost',all_stkwhcost,igroup);
   saveUpdateWatch('CyearlyFuelCost',all_yearlyFuelCost,igroup);
   saveUpdateWatch('CyearlyMaintCost',all_avgMaintCost,igroup);
   saveUpdateWatch('CendValue',all_endValue,igroup);

   for (im=0;im<cars.length;im++) {
       im1=im+1;
       saveUpdateWatch('Car'+im1+'EndValue',endValues[im],igroup);              // depreaciated value
       saveUpdateWatch('Car'+im1+'MilesDriven',cars[im].milesDriven,igroup);   // miles drive (excluding starting mileage)
   }

   saveUpdateWatch('CdiscountedGCosts',all_discountedGCosts,igroup);
   saveUpdateWatch('CdiscountedYCosts',all_discountedYCosts,igroup);
   saveUpdateWatch('CdiscountedNCosts',all_discountedNCosts,igroup);

  return {status:"nosave"};
}

//==========================      stpct
// compute maintainance given  vector (dvals) of yearly mileage at ,and miles driven
function figYearlyMaint(dvals,milesPerYear) {
  var iy,iset,cumMiles,im,rnul,insur,repairs,totmm;
  var res=[];
  var  seps=[36000,60000,100000,150000] ;

  for (iy=1;iy<dvals.length;iy++) {
    iset=5;
    cumMiles=dvals[iy];
    for (im=0;im<seps.length;im++) {
       if (cumMiles<seps[im]) {
            iset=im+1; break;
       }
    }

    rmult=get_elemNumber('repair'+iset,0);
    insur=get_elemNumber('insurance'+iset,0);
    repairs=rmult*milesPerYear ;
    totmm=insur+repairs;
    res[iy]=totmm;
  }

  return res ;
}


//===========================
// populate the summary tables
function doReport(thisElement,changedElement,icall,alist,origId,cElem) {
  var ncars,im,isCar,cname,fuelcost=[],im2,cdiff,carPrice,enviroBuildPRice,fullPrice,maint,endval,yearly,netcosts,grosscosts,ltMiles,stMiles,irate;
  var yearly,netcosts,grosscosts,gp,kp,avgmpg,avgmpk,regBuild,hybBuild,carWeight ,ctype ,evshort;

   if (origId==0)   return {status:"nosave"};
   ncars=get_elemNumber('nCars',1);
   nYears=get_elemNumber('nYears',1);
   stMiles=get_elemNumber('shortTripMiles',1);
   ltMiles=get_elemNumber('longTripMiles',1);
   irate=get_elemNumber('iRate',1);
   gp=get_elemNumber('fullGasPrice',0);
   kp=get_elemNumber('fullKwhPrice',0);
  regBuild=get_elemNumber('gallonsPerLbNormal',0);
  hybBuild=get_elemNumber('gallonsPerLbHybrid',0);
 evshort='n.a.';

  for (var im=1;im<=ncars;im++) {
     isCar=get_elemValue('isCar_'+im,0);
     ctype=get_elemValue('carType_'+im,0);
     if (isCar!='1') {                  // collection
        cname=get_elemValue('collectionName_'+im,'collection');
        fuelcost[im]=get_elemNumber('CyearlyFuelCost_'+im) ;
        fullPrice=get_elemNumber('CtotalPrice_'+im);   carPrice=fullPrice;
        enviroBuildCost='...';
        maint=get_elemNumber('CyearlyMaintCost_'+im) ;
        endval=get_elemNumber('CendValue_'+im);
        yearly=get_elemNumber('CdiscountedYCosts_'+im);
        netcosts=get_elemNumber('CdiscountedNCosts_'+im);
        grosscosts=get_elemNumber('CdiscountedGCosts_'+im);
        avgmpg=get_elemNumber('CaverageMPG_'+im);
        avgmpk=get_elemNumber('CaverageMPK_'+im);
        evshort=get_elemNumber('CyearlyEVrangeFailure_'+im);

     } else {                             // a car
         cname=get_elemValue('carName_'+im,'collection');
         fuelcost[im]=get_elemNumber('yearlyFuelCost_'+im) ;
         fullPrice=get_elemNumber('totalPrice_'+im);
         carPrice=get_elemNumber('carPrice_'+im);
         enviroBuildCost=fullPrice-carPrice ;

         maint=get_elemNumber('yearlyMaintCost_'+im) ;
         endval=get_elemNumber('endValue_'+im);
        yearly=get_elemNumber('discountedYCosts_'+im);
        netcosts=get_elemNumber('discountedNCosts_'+im);
        grosscosts=get_elemNumber('discountedGCosts_'+im);
        avgmpg=get_elemNumber('averageMPG_'+im);
        avgmpk=get_elemNumber('mpKwh_'+im);
        if (ctype=='4')evshort=get_elemNumber('yearlyEVrangeFailure_'+im);
      }

     saveUpdateWatch('summaryName',cname,im);
     saveUpdateWatch('summaryNameR',cname,im);
     saveUpdateWatch('totalName',cname,im);
     saveUpdateWatch('summaryCost',fuelcost[im],im);

     saveUpdateWatch('totalFuel',fuelcost[im] ,im);
     saveUpdateWatch('totalEnviroBuild',enviroBuildCost,im);
     saveUpdateWatch('totalcarPrice',carPrice,im);
     saveUpdateWatch('totalMaint',maint,im);
     saveUpdateWatch('totalEnd',endval,im);

     saveUpdateWatch('totalYearly',yearly,im);
     saveUpdateWatch('totalNet',netcosts,im);
     saveUpdateWatch('totalGross',grosscosts,im);
     saveUpdateWatch('totalEVshort',evshort,im);
     saveUpdateWatch('summaryAverageMPG',avgmpg,im);
     saveUpdateWatch('summaryAverageMPK',avgmpk,im);

  }
//    saveUpdateWatch('diff_'+im,' ==',im);
  for (im=1;im<=ncars;im++) {
       for (im2=1;im2<=ncars;im2++) {
          cdiff=fuelcost[im2]-fuelcost[im];
          saveUpdateWatch('diff_'+im,cdiff,im2);
          goo=document.getElementById('diff_'+im+'_'+im2);
          goo.style.backgroundColor="lime";
          if (im2<im){
            goo=document.getElementById('diff_'+im+'_'+im2);
            goo.style.backgroundColor="#dadbda";
         }
       }
  }

  update_elemValue('nYearsSummary',nYears);
  update_elemValue('stSummary',stMiles);
  update_elemValue('ltSummary',ltMiles);
  update_elemValue('irateSummary',irate);
  update_elemValue('gaspriceSummary',gp);
  update_elemValue('kwhpriceSummary',kp);

  window.location.hash='tablesSummary';

  return {status:"nosave"};

}

//============================
// ez entry -- read data and set main elements
function doEzEntry(thisElement,changedElement,icall,alist,origId,cElem) {
  var tmp,ncars;
var aprice,amileage,aweight,abookvalue,astmpg,altmpg,aevrange,ampk,im,atype,isnew,tmp,nname ;

   if (origId==0)     return {status:"nosave"};
 
   ncars=get_elemNumber('ez_nCars',2);
   update_elemValue('nCars',ncars);

   tmp=get_elemNumber('ez_gasRetailCost',2);
   update_elemValue('gasRetailCost',tmp);

   tmp=get_elemNumber('ez_kwhRetailCost',2);
   update_elemValue('kwhRetailCost',tmp);
   tmp=get_elemNumber('ez_carbonPrice',2);
   update_elemValue('carbonPrice',tmp);

   tmp=get_elemNumber('ez_workDayDistance',2);
   update_elemValue('workDayDistance',tmp);
   update_elemValue('nWorkDays',350);
   update_elemValue('weekendDistance',0);
   update_elemValue('nWeekendDays',0);

   tmp=get_elemNumber('ez_longTripMiles',2);
   update_elemValue('longTripMiles',tmp);

   doWatch('nCars');
   doWatch('gasRetailCost');
   doWatch('kwhRetailCost');
   doWatch('carbonPrice');
   doWatch('longTripMiles');
   doWatch('workDayDistance');

   doWatch('generalFlag');

// now do car stuff

  for (im=1;im<=ncars;im++) {
     update_elemValue('isCar_'+im,1);       // no collections
     doWatch('isCar_'+im);
//     document.getElementById('debugOutput').innerHTML+='<br>ez make car not collection '+im+' : ' +get_elemValue('isCar_'+im);
   nname=get_elemValue('ez_name'+im,'');
          update_elemValue('carName_'+im,nname);

   isnew=get_elemValue('ez_new'+im,0);
   if (isnew=='1') {
      aprice=get_elemValue('ez_price'+im,0);
          update_elemValue('carPrice_'+im,aprice);
      aweight=get_elemValue('ez_weight'+im,0);
          update_elemValue('carWeight_'+im,aweight);
      abookvalue=parseInt(0.9*aprice);
          update_elemValue('currentValue_'+im,abookvalue);
          update_elemValue('ez_bookValue'+im,abookvalue);
          update_elemValue('carMileage_'+im,0);

  } else {
      update_elemValue('carPrice_'+im,0);
      update_elemValue('carWeight_'+im,0);

      aprice=get_elemValue('ez_bookValue'+im,0);
          update_elemValue('currentValue_'+im,aprice);
      amileage=get_elemValue('ez_mileage'+im,0);
          update_elemValue('carMileage_'+im,amileage);
  }



   atype=get_elemValue('ez_carType_'+im,0);
   update_elemValue('carType_'+im,atype);

   zoob=doWatch('carType_'+im);

   if (atype==1 || atype==2 || atype==3) {
      astmpg=get_elemValue('ez_stMPG_'+im,0);
          update_elemValue('stMPG_'+im,astmpg);
      altmpg=get_elemValue('ez_ltMPG_'+im,0);
          update_elemValue('ltMPG_'+im,altmpg);
   }
   if (atype==4 || atype==3) {
      aevrange=get_elemValue('ez_evRange_'+im,0);
          update_elemValue('EVRange_'+im,aevrange);
      ampk=get_elemValue('ez_mpk_'+im,0);
          update_elemValue('mpKwh_'+im,ampk);
   }
   if (atype==4) {
          update_elemValue('stMPG_'+im,0);
          update_elemValue('ltMPG_'+im,0);
   }
   if (atype==2 || atype==1) {
          update_elemValue('EVRange_'+im,0);
          update_elemValue('mpKwh_'+im,0);
   }
   turnDisplayOn('specsRows_'+im,'OFF','doEz entry');
   turnDisplayOn('basicCostsTable','OFF','doEz entry');
   turnDisplayOn('useageDataTable','OFF','doEz entry');


// If called by function (not a watchCall: figValues(2,igroup)   (igroup=0 for general changes)
 }                                      // im'th car

// now do the specific flags
  for (im=1;im<=ncars;im++) {
      tmp=doWatch('specificFlag_'+im);
   }

 doWatch('ezFlag');                   // and some ez stuff

 return {status:"nosave"};
}


//====================
// save report to new window/tab
//=================
// create a report, display in new window
function containerToTab(which1) {

var d2,atime,atime2,a,a2,ifoo,dw;

   dw=window.open('','');
   dw.document.open('text/html');
  atime=new Date() ;
  atime2=atime.toDateString()+' '+atime.toTimeString() ;

   a="<html><head><title>Car costs: report</title></head>";
   a += "<body> ";
   a +='<h3 align="center"s > Calculate costs of car ownership (with enviro costs): Report</h3> ';
   a +='<em>generated on '+atime2+'</em></br>';

   ifoo=document.getElementById(which1);
   if (!ifoo) abortJavaScript('Error in containerToTab: no element with id= '+which1);
   a2=ifoo.innerHTML;
   a += a2 ;
   a=a+'\n <table><tr><th>Notes: </th><td> <textarea rows="8" cols="120">You can enter notes in here \n </textarea></td></tr></table>';

   a += "</body></html>    ";
   dw.document.write(a);
   dw.document.close();

}
