// generic javascript functions

/*  :::::::::::::::::::::::::
Copyright 2013. Daniel Hellerstein (danielh@crosslink.net)

This file is part of carCosts2.

    carCosts2 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    carCosts2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with carCosts2.  If not, see <http://www.gnu.org/licenses/>.

 ::::::::::::::::::::: */

//======
//  browser independent add event listenter
// http://stackoverflow.com/questions/6348494/addeventlistener-vs-onclick
function addEvent(element, evnt, funct){
  if (element.attachEvent) {
   return element.attachEvent('on'+evnt, funct);
 } else {
   return element.addEventListener(evnt, funct, false);
 }
}
// example
//addEvent(
//    document.getElementById('myElement'),
//    'click',
//    function () { alert('hi!'); }
//);

//====================
// pull attribute out of element using element's id
function readAttribute(aid,attlist,adef,noTrim) {

var anode,mlen,anatt,m2,tmp;
 if (arguments.length<3) adef='';
 if (arguments.length<4) notrim='0';

  var anode=document.getElementById(aid);
  if (!anode) return adef;               // no such id, return ''

  attlist='xx   '+attlist.toUpperCase()+'   ';
  try {
    var mlen=anode.attributes.length;
  }
  catch(err) {                          // possibly a comment  (anode.attributes.length doesnt exist)
    return adef ;                           // no attributes (matching attlist) found -- return default
   }
  for (var m2=0; m2<mlen;m2++) {
     anatt=' '+trim(anode.attributes[m2].name.toUpperCase())+' ' ;
     if (attlist.indexOf(anatt)>0)  {    // exist in list of desired attributes
        tmp=anode.attributes[m2].value ;       // if asString, return first of the "attlist" attributes found (as a string)
        if (trim(noTrim)!=='1') tmp=trim(tmp);
        return tmp;
     }
  }
  return adef ;
}
//====================
// pull attribute out of element, given a node
function readAttributeNode(anode,attlist,adef,noTrim,goo) {

var anode,mlen,anatt,m2,tmp;
 if (arguments.length<3) adef='';
 if (arguments.length<4) notrim='0';

  attlist='xx '+trim(attlist.toUpperCase())+' ';

  try {
    var mlen=anode.attributes.length;
  }
  catch(err) {                          // possibly a comment  (anode.attributes.length doesnt exist)
    return adef ;                           // no attributes (matching attlist) found -- return default
   }
  for (var m2=0; m2<mlen;m2++) {
     anatt=' '+trim(anode.attributes[m2].name.toUpperCase())+' ' ;
     if (attlist.indexOf(anatt)>0)  {    // exist in list of desired attributes
        tmp=anode.attributes[m2].value ;       // if asString, return first of the "attlist" attributes found (as a string)
        if (trim(noTrim)!=='1') tmp=trim(tmp);
        return tmp;
     }

  }
  return adef ;
}



//===============
// read an elements "value". What is returned depends on  the tag and type attribute
//
//  If tagname is input, depends on the "type"...
//
//  If text,with type of "text", or a <textarea> read using xx.value (the stuff entered in the text box).
//     return value (the stuff entered in the text box).
//  If hidden,
//           return value (the stuff entered in the text box).
//  If checkbox,
//        see if it is checked, and return its value attribute. If not checkec, return either value of noValue attribute if one is specified, otherwise defval
//  If radio,
//        if e1 points to the ID of a radio button,
//               see if it is checked, and return its value attribute.  If not checkec, return either value of noValue attribute if one is specified, otherwise defval
//                Note: for "options" ... see if it is  selected.
//                If not checked, return "defval"
//         if e1 points to the NAME of a set of radio buttons
//               find the one that is checked, and return its value. If none are checked, return defval (do NOT look for a "noValue" attribute)
//  If option
//      If selected, return value. Otherwise, return defval (hence, noValue attribute is NOT supported)
//  If  select,
//          return array of values for all options (in the select) that are selected. Empty array if none chosen
//
// If tagname is textarea
//     return value (the stuff entered in the text box).
//
//  If other tagname (such as span)
//      return innerhtml
//
// Defval can be null or undefined (NOT quoted)
// Modifiers: transform value returned
//       Modifiers is a string that can contain any set of these letters (one or more, though try not
//      to use contradictory modifiers, like U and L, together)
//          N=convert to integer
//          F=converto float
//          L=make lower case,
//          U or 1=make upper case,
//          S=strip spaces,
//          R=remove all spaces.

function get_elemValue(e1,defval,modifiers) {
  var tg,useval,atype,tmpe1,isname='' ;

  if (arguments.length<2) defval='' ;
  if (arguments.length<3) modifiers='';

//ii=document.getElementById('CyearlyEVrangeFailure_1');
//if (!ii) alert(' no everange ');

  if (typeof(e1)=='string') {                       // not a node, so look for element with this ID
      tmpe1=e1;


      e1=document.getElementById(tmpe1);
      if (!e1) {
         e1s=document.getElementsByName(tmpe1) ;
         if (e1s.length==0) {
              var trace = printStackTrace();           //Output however you want!
              vtmp=confirm('Warning: could not find element with id or name= '+tmpe1+' (defval='+defval+'\n\n'+  trace.join('\n\n'));
              if (vtmp)abortJavaScript(' Aborting. ');
              return defval;
         }
         isname=tmpe1 ;
         e1=e1s[0];    // use the first element
      }
   }

   if (e1==null || typeof(e1)!='object' ) return defval ;            // not a node, give up

   tg=e1.tagName ;

   if (tg=='_flagVar') {
     useval= e1.value ;   // a flag!

   } else {               // not flag
    try {
      tg=trim(tg.toUpperCase());                      // how to process depend on tagname
    }
    catch(err)  {
          tt=printStackTrace();
         alert('Error in get_elemValue, probably an object passed in: '+tt.join('\n\n'));
   }

      if (tg=='INPUT' ) {                                   // input element
        var atype=e1.getAttribute("type");
        if (atype==null) {
          alert('Error: no type attribute in: '+ e1.outerHTML);
          return defval ;
        }
        atype=atype.toUpperCase();

        if (atype=='RADIO' || atype=="CHECKBOX") {                // is this something that needs to be  "checked"
           useval=get_elemValueRadioCheck(e1,defval,atype,isname) ;
//        alert(' in racio with '+e1.id+'='+useval);
        } else {
           useval=e1.value;                                  // either TEXT, or checked button
           if (!useval) useval=e1.getAttribute('value') ;             // sometimes .value doesn't work right
        }

      } else if (tg=='TEXTAREA' ) {                                   // input element
         useval=e1.value;
         if (!useval) useval=e1.getAttribute('value') ;             // sometimes .value doesn't work right


      } else if (tg=='OPTION' || tg=='SELECT' ) {
           useval=getSelectValue(e1,defval) ;

      }  else {                                    // all other tags
          useval=e1.innerHTML ;
      }

      if (typeof(useval)=='undefined' || useval==null || useval==='' ) {                   // should never happen..
          return defval;
      }
  }                                  // not flag

// modify...
  if (modifiers==='') {
      return useval ;                   // none
  }

  modifiers=' '+modifiers; modifiers=modifiers.toUpperCase() ;                               // make sure it is a string
  if (typeof(useval)=='string') {                        // change a string?
    if (modifiers.indexOf('1')>-1) useval=useval.toUpperCase() ;
    if (modifiers.indexOf('U')>-1) useval=useval.toUpperCase() ;
    if (modifiers.indexOf('L')>-1) useval=useval.toLowerCase() ;
    if (modifiers.indexOf('0')>-1) useval=useval.replace(/^\s+|\s+$/g, '');    // strip leading/trailing spaces
    if (modifiers.indexOf('S')>-1) useval=useval.replace(/^\s+|\s+$/g, '');     // strip leading/trailing spaces
    if (modifiers.indexOf('R')>-1) useval=useval.replace(/\s/g,'') ;            // remove all spaces
    if (trim(useval)!=='') {
        if (modifiers.indexOf('N')>-1) useval=parseInt(useval);
        if (modifiers.indexOf('F')>-1) useval=parseFloat(useval);
    }
  }

  return useval ;
}



//===================
// This is used by get_elemValue.
//     rnode must be a <input> node (not a string) -- with a type of radio or checkbox
//     Or, if isname!='', rnode is ignored
// If checkbox:
//    Is it checked: if so, return value
//    If not: return value of noCheck attribute, or the adef argument ('' if adef not specified)
// If radio:
//    If isname='' : rid points to a particular button
//        return value of button if checked. If not checked, return "noCheck" attriute, or adef
//    isname!=''  : rid is ignored. isname used this as the "name" of this set of radio buttons
//                Find which one is checked and return itsvalue
//                If none checked, return adef

function get_elemValueRadioCheck(rnode,adef,atype,isname) {

var issel,avalue,im,alist;

if (atype=='CHECKBOX') {
   issel=rnode.checked ;
   if (issel) return rnode.value;
   avalue=readAttributeNode(rnode,'nocheck none',adef);   // default if no radio button checked in this set, or checkbox not checked
   return avalue ;
}

// else, radio button?

if (atype!=='RADIO') return adef ;

// radio button. The "set", or a particular one?
if (isname=='')  {             // id: so refers to a particular radio button. Is this button checked?
  if (rnode.checked) {
     return rnode.value ;
  }
  avalue=readAttributeNode(rnode,'nocheck none',adef);   // not checked -- use a noCheck attribute?
  return avalue;
}

// if isname set, then which button in this set of buttons is checked (adef if none were checked)
alist=document.getElementsByName(isname);
for (im=0;im<alist.length;im++) {
   issel=alist[im].checked ;
   if (issel) return alist[im].value ;
}

return adef ;
}

//===================
// for element with id=rid
// is it a option or a select. If not, return adef
// otherwise, return array of all values selected
// if problem, return adef as string

function getSelectValue(rid,adef) {

var adef,im,issel,rnode,atag,atype;
var gots,asel,im,rnodeUse;

if (arguments.length<2) adef='';

if (typeof(rid)=='string') {                       // not a node, so look for element with this ID
   rnode=document.getElementById(rid);
   if (!rnode) return adef ;             // not a node
} else {
   rnode=rid;
}
atag=rnode.tagName.toUpperCase();

if (atag!=='OPTION' && atag!=='SELECT') return adef ;              // not option or select

if (atag=='OPTION') {  // find parent
 //  rnodeUse=rnode.parentNode ;
  if (rnode.tagName.toUpperCase()!=='SELECT') return adef ;   // wierd, give up
  if (rnode.selected) return rnode.value ;
  return adef;
}


// else, select
gots=[];                     // ready to look for selected options
for (var im=0;im<rnode.options.length;im++) {
   asel=rnode.options[im];
   if (asel.selected) gots.push(asel.value) ;
 }

return gots;
}


//===========================
// alternative to get_elemValueNumber
// options are a string that contain (space delimited)  :  INT  BLANKOK or NDEC=n  NOT$ (NOT$ means "do not strip $ signs)
function get_elemNumber(anelem,adef,opts) {
var idollar,idec,aa,aa2,aa3,vv;

if (arguments.length<3) opts='' ;
opts=' '+trim(opts.toUpperCase())+' ';

var blankOk=0,ndec='',toint=0,stripdollar=1 ;

if (opts.indexOf(' BLANK ')>-1 || opts.indexOf(' BLANKOK ')>-1) blankOk=1;
if (opts.indexOf(' I ')>-1 || opts.indexOf(' INTEGER ')>-1 || opts.indexOf(' INT ')>-1)  toint=1;
idec=opts.indexOf(' DEC='); if (idec<0) idec=opts.indexOf(' NDEC=');
idollar=opts.indexOf(' NOT$') ;  if (idollar>-1) stripdollar=0 ;
if (idec>-1) {
   aa=opts.substr(idec+1);
   aa2=aa.split(' ',1);
   aa3=aa2[0].split('=');
   if (aa3.length>1) ndec=aa3[1];
}
vv=get_elemValueNumber(anelem,adef,toint,ndec,blankOk,stripdollar);

return vv ;
}



//=-====================
// get element value that must be a number.
//  If nan or '', use default.
//  If toinc=1, parseInt it. Otherwise, parseFloat it.
//   if ndec specified, then trim decimal points (and then convert back to number)
// Hence, either a type =number is returned, or a string containing the adef
// if default is not a number, and element value not a number, return default

function get_elemValueNumber(anelem,adef,toint,ndec,blankOk,stripdollar) {
  var v1;
  if (arguments.length<2) adef=0;
  if (arguments.length<3) toint=0;
  if (arguments.length<4) ndec='';
  if (arguments.length<5) blankO='0' ; blankOk=trim(blankOk);
  if (arguments.length<6) stripdollar='1' ;


  v1=get_elemValue(anelem,adef);
  try {
     v1=v1.replace(/\,/g,'');
  }
  catch(err) {
     alert('getElemValueNumber failed: '+anelem+' , with value='+v1);
      var trace = printStackTrace();           //Output however you want!
      var vtmp=confirm(trace.join('\n\n'));
      if (vtmp)abortJavaScript(' Aborting. ');
  }

  if (stripdollar=='1')  v1=v1.replace(/\$/g,'');

  if (trim(v1)==='' || isNaN(v1)) {                          // non-numeric entry... what to do?
     if (blankOk=='1' && trim(v1)=='') return '' ;   // '' entered, and '' is a legit value (i.e.; a "use default" signal)
     if (trim(adef)==='' || isNaN(adef)) return adef;     // '' or nan entered, and adef nan, return adef (could be '', but may be something else
     v1 =adef;                                  // use adef as the entered value, and continue procesing
  }

  v1=parseFloat(v1);
  if (trim(ndec)!=='') v1=v1.toFixed(ndec);   // can't have toFixed on a string
  if (toint==1) {
     v1=parseInt(v1);
  } else {
     v1=parseFloat(v1);
  }

  return v1 ;
}



//=======================================================
// set an elements "value". 
// For input type="text", the value (of the text box) is changed.
// For textarea, the value of the (multi row textbox) is changed
// For most radio, checkbox, select and option, this does not actually change the value
//  Rather, it select the value if the useval matches (case sensitively) the value of the element
//  If a name is given that matches a set of radios, the radio button that matches the useval is checked
//  If an id is given, just that element is compared to useval
//  If checkbox or option, just the element is compared to useval
//  If select, the option that matches useval is selected (just one!)
// For other tags, the innter html is changed
 //
//   aelem : an element. If a string, id with this name is lookedup.
//   useval  : value to "set" the elements value field (or attribute) to
//           Note: spaces are trimmed from useval (and from element values when comparing)
// returns 1 if success, 0 if failure (i.e.; if no such Id with aelem name)

function set_elemValue(aelem,useval) {
  var tg ,atype,isname='',e1s,e1,trace,oldval,alist,im ;

  useval=trim(useval);

  if (typeof(aelem)=='object' && typeof(aelem.length)!='undefined')   aelem=aelem[0] ;  // array of elements? use first one [0]

  if (typeof(aelem)=='string') {
      var e1=document.getElementById(aelem);
      if (!e1) {
         e1s=document.getElementsByName(aelem) ;
         if (e1s.length==0) {
              var trace = printStackTrace();           //Output however you want!
              alert('Warning in set_elemValue: could not find element with id or name= '+aelem+'\n\n'+  trace.join('\n\n'));
              return 0;
         }
         isname=aelem ;
         aelem=e1s[0];    // use the first element
      }      else {
           aelem=e1;
      }
   }

   tg=aelem.tagName ;

   try {
       tg=trim(tg.toUpperCase());                      // how to process depend on tagname
   }
   catch(err)  {
         tt=printStackTrace();
         alert('Error in set_elemValue, probably an object passed in: '+tt.join('\n\n'));
         return 0;
   }

   if (tg=='INPUT') {
        atype=aelem.getAttribute("type");
        if (atype==null) {
          alert('Error: no type attribute in: '+ aelem.outerHTML);
          return 0 ;
        }
        atype=atype.toUpperCase();

        if (atype=='CHECKBOX') {
            oldval=trim(aelem.value);
            if (oldval==useval) aelem.checked=true;
            return 1;
        }
        if (atype=='RADIO' ) {                // is this something that needs to be  "checked"
             if (isname=='') {
                oldval=trim(aelem.value);
                if (oldval==useval) aelem.checked=true;
                return 1;
             }   // else, check all radios with this name

             alist=document.getElementsByName(isname);
             for (im=0;im<alist.length;im++) {
                  if (trim(alist[im].value)==useval) {
                       alist[im].checked=true;
                  } else {
                       alist[im].checked=false;
                  }
             }
             return 1;
        }

        aelem.value=useval ;                   // otherwise, hidden or text, just set its value (for text, that's the input box content
        return 1;
   }

   if (tg=='TEXTAREA') {        // set textarea's content
        aelem.value=useval ;
        return 1;
   }

   if (tg=='OPTION') {
            oldval=trim(aelem.value);
            if (oldval==useval) aelem.selected=true;
            return 1;
   }

   if (tg=='SELECT') {                // only matching option selected (no multiple selections)
       for (var im=0;im<aelem.options.length;im++) {
          if (trim(aelem.options[im].value)==useval) {
           aelem.options[im].selecte=true;
          } else {
           aelem.options[im].selecte=false;
          }
       }
       return 1;
 }


// otherwise, set innerhtml
  aelem.innerHTML=useval ;
  return 1 ;
}



//===========
// convert a number of seconds to hh:mm:ss format
function Seconds_ToTime(towait) {
  if (isNaN(towait)) return towait ;              //ignore non numbers
  if (towait<10) return ':0'+towait ;
  if (towait<60) return ':'+towait ;
  var thr=0;                     // convert seconds to hr:min:sec
  var tmin=Math.floor(towait / 60);
  var tsec=towait -  (tmin*60) ;
  if (tsec<10) tsec='0'+tsec ;

  thr=Math.floor(tmin/60) ;
  tmin=tmin-(thr*60) ;
  if (tmin<10) tmin='0'+tmin ;
  thr1=''
  if (thr>0) {
     thr1=thr ;
     if (thr1<10) thr1='0'+thr1 ;
     thr1=thr1+':';
  }
  var dahh=thr1 + tmin +':' + tsec ;
 if (dahh.indexOf('.')>0) {                     // strip out fractional seconds
        dahh=dahh.split('.');
        return dahh[0];
 }
  return dahh ;

}



// ==================================
// toggle display between none and block. Or, set display to ado (if ado is specified)
function toggleDisplay(adiv,ado) {
 var ii=document.getElementById(adiv) ;

 abortJavaScript(adiv+' : toggle display is deprecated: use turnDisplayOn ');

 if (!ii) {
   alert('Error: no such toggleDisplay= '+adiv);
   return 0;
 }
 if (arguments.length>1) {
   ii.style.display=ado ;
   return 0
 }
 var ss=ii.style.display.toUpperCase() ;

 if (ss.toUpperCase()=='NONE'){
   ii.style.display='block'
 } else {
    ii.style.display='none';
 }
 return 0;
 }



 //=================
 // show one of the keywords help divs in the fixed position keywordHelpMain div
 // dakey is an id of the help div to display, a '0' to close the box, or '*' to display all of them
function showKeyword(dakey,hlist) {
var turnon,m,m2,isnow,hmain;

dakey=trim(dakey);

if (arguments.length<2) {

  var iee=isIE(0);       // shocking: Ie stinks on ice!
  if (iee) {
     hlist=getElementsByName_ie('__akeyword__','div');
  } else {
     hlist=document.getElementsByName('__akeyword__');    // use of goofy name means I don't have to use childNodes. Call me lazy
  }
}


if (dakey=='0' || dakey=='') {
  for (var m2=0;m2<hlist.length;m2++) {                           // overkill, but whateva
              hlist[m2].style.display='none'  ;
   }
   turnDisplayOn('keywordHelpMain','none');
   return 0;
}

// * means show all
if (dakey=='*') {
  for (var m=0;m<hlist.length;m++) {
       hlist[m].style.display='block'  ;
  }
  turnDisplayOn('keywordHelpMain');                                 // probably redundant...

  return 0 ;
}

// display/undisplay just one
hmain=document.getElementById(dakey);                                      // make sure it exists first
if (!hmain) {
   alert('Error in showKeyword: no such id: '+dakey);
   return 0;
}
isnow=trim(hmain.style.display).toUpperCase() ;
turnon=1;
if (isnow!='NONE') turnon=0;

// undisplay all of them (kind of overkill, but whateva)
 for (var m=0;m<hlist.length;m++) {
       hlist[m].style.display='none'  ;
 }

if (turnon==1) {
   hmain.style.display='block';             // display this one
   turnDisplayOn('keywordHelpMain');                   // and display the parent containier
} else {
   turnDisplayOn('keywordHelpMain','none');                    // close parent container
}
return 1;
}


///====== getelementsbyname for stupid ie
// tag can be *
function getElementsByName_ie(name,tag) {
  var iarr,i,att ;
   if (arguments.length<2) tag='*';
   var elem = document.getElementsByTagName(tag);
   var arr = new Array();
     for(i = 0,iarr = 0; i < elem.length; i++) {
          att = elem[i].getAttribute("name");
          if(att == name) {
               arr[iarr] = elem[i];
               iarr++;
          }
     }
     return arr;
}

//=-==============================
// display an element  based on its tagname (i.e.; display="block" if <div>. Returns nothing
// a1 can be an id value (a string), or  a string delimited list of many id values, or pointer to a node
// or, to turn off, use a 2nd argument of "0" or "off" or "none"
// or to toggle, 2nd arg of 'toggle'
// 3arg is optional: a message to display if an error
// return 1 if the display is   on, 0 if is now off
function turnDisplayOn(a1s0,doit,amess) {
  var doOff=0,doToggle=0,isnode,im,a1,a1s;
  if (arguments.length<3) amess=' (n.a.) ';

  if (typeof(a1s0)=='string') {
      a1s=getWord(trim(a1s0));
      for (var im=0;im<a1s.length;im++) {
         ia1=document.getElementById(trim(a1s[im]));
         if (!ia1) abortJavaScript('Error: no such id in turnDisplayOn at '+amess+' : '+a1s[im] + ' [ in ' +a1s0+']');
         a1s[im]=ia1 ;
      }
  } else {
      a1s=[a1s0];
  }

  if (arguments.length<2) doit=''; doit=trim(doit.toUpperCase());
  if (doit=='NONE' || doit=='NO' || doit=='OFF' || doit==='0') doOff=1;
  if (doit=='TOGGLE') doToggle=1;

 var dispType={DIV:"block",SPAN:"inline",TR:"table-row",LI:'list-item',TD:'table-cell',TABLE:'table',TH:'table-cell',CAPTION:'table-caption',TBODY:'table-row-group',COLGROUP:'table-column-group'};
 var atag,astyle;

for (im=0;im<a1s.length;im++) {
  a1=a1s[im] ;

  atag=a1.tagName.toUpperCase();

  if (doToggle==1) {
      doOff=0;
      if (a1.style.display.toUpperCase()!=='NONE') doOff=1;
  }
  if (doOff==0) {
      astyle='block';
      if (typeof(dispType[atag])!=='undefined') astyle=dispType[atag];
  } else {
     astyle='none';
  }
// if (document.getElementById('debugNow').checked) alert(' turnon '+a1s0 +' using '+astyle);
  a1.style.display=astyle;
}
return doOff ;
}


// ============
// toggle views. Slightly fancier than toggleDisplay, since it also toggles the message (of the link that
// toggleDisplay the target element
 function toggleView(id1,mess1,mess2,idswitch) {
   var newstate,newMess,jd,vstate,m,ids;
   jd=document.getElementById(idswitch) ;
   vstate=jd.getAttribute('vState');
   if (vstate=='1') {
       newMess=mess2;
       newstate=2;
   } else {
       newMess=mess1;
       newstate=1;
   }
   jd.setAttribute('vState',newstate);
   jd.innerHTML=newMess;

   id1=trim(id1);
   ids=id1.split(' ');
   for (m=0;m<ids.length;m++)  turnDisplayOn(ids[m],'toggle') ;                  // don't forget this!
   return 0;
 }

//==========================
// switch views (toggle display between to 2 divs;
function switchViews(id1,id2,mess1,mess2,idswitch) {

var ii1,ii2,iiSw;

   ii1=document.getElementById(id1);
   if (!ii1) {
      alert('Error in switchViews: no such id1 '+id1);
      return 0;
   }
   ii2=document.getElementById(id1);
   if (!ii2) {
      alert('Error in switchViews: no such id2 '+id2);
      return 0;
   }
   iiSw=document.getElementById(idswitch);
   if (!iiSw) {
      alert('Error in switchViews: no such idSwitch '+idswitch);
      return 0;
   }
// if ii1 is not displayed, view it and hide ii2
  if (ii1.style.display.toUpperCase()=='NONE') {
      ii1.style.display='block';
      iiSw.innerHTML=mess1 ;
      if (id1!==id2) ii2.style.display='none';
  } else {
      ii1.style.display='none';
      iiSw.innerHTML=mess2 ;
      if (id1!==id2) ii2.style.display='block';

  }
   return 0;

}

function trim(str,which) {
  if (typeof(str)=='number') {str=str+''; return str; }
  if (typeof(str)!='string') return str;
  if (arguments.length<2) {
      which=''
   } else {
    which=which.toUpperCase();
    which=which.replace(/\s+/g,'')
    which=which.substring(0,1);
  }
  if (which=='L')  return str.replace(/^\s+/, '');
  if (which=='R') return str.replace(/\s+$/, '');
  return str.replace(/^\s+|\s+$/g, '');                         // trim both sides

}

//===================
// given a list, create a table
// alist: array of string element to use when creating table
// ncols: number of columns in this table. If 2 elment array, 2nd element is "new row" signal (if not specified, 5 is used)
//              the new row signal, if specified, is compared to elements in alist. If an element matches
//              (exactly, case and spaces are used), then a new row is started (the element(s) that match
//              will NOT be included in the table
// astyle: style to use when displaying elements of table (use '' if no extra styles are to be added)
// th1  : if specified, use this as top row(s) of table, using <th>  (use 0 to ignore)
// tablespec: string to include verbatim in the <table >

function makeATable(alist,ncols2,astyle1,athrow,tablespec) {
var ncols,newRowSignal,lookForSignal=0,newRowSignal='';
var astyle,im,iastyle,bstyle,igoo ;

if (arguments.length<2) ncols2=5 ;
if (arguments.length<3 || astyle1===0 ) astyle1='';
if (arguments.length<4 || athrow===0 || athrow==='') athrow=[] ;
if (arguments.length<5) tablespec='';

if (typeof(ncols2)=='object') {
  ncols=ncols2[0];
  newRowSignal=ncols2[1];
  lookForSignal=1;
} else {
  ncols=ncols2;
}

astyle=[];
if (typeof(astyle)!=='object') {
   astyle[0]=astyle1;
   iastyle=0;
} else {
  for (var im=0;im<astyle1.length;im++) astyle[im]=astyle1[im];
  iastyle=astyle.length-1;
}

 for (var im=0;im<astyle1.length;im++) {
   if (astyle[im]!=='') astyle[im]=' style="'+astyle[im]+'" ';
 }

atable='<table '+tablespec+'> \n '

if (athrow.length>0) {
   iat=0;
   arow='';
   for (var m=0;m<athrow.length;m++) {
        iat=iat+1;
        if (iat>ncols) {
          atable=atable+'   <tr>'+arow+'</tr> \n ';
          arow='';
          iat=1;
        }
         igoo=iat-1;
         if (igoo>iastyle) igoo=iastyle;
         bstyle=astyle[igoo];

        atd='<th '+bstyle+'>'+athrow[m]+'</th>';
        arow=arow+atd ;
   }
   if (arow!=='') {
          atable=atable+'<tr>'+arow+'</tr> \n ';
          arow='';
   }
}

if (alist.length>0) {
   iat=0;
   arow='';
   for (var m=0;m<alist.length;m++) {
        iat=iat+1;

        if (lookForSignal==1 && alist[m]==newRowSignal) {
          atable=atable+'   <tr>'+arow+'</tr> \n ';
          arow='';
          iat=1;
        } else {

          if (iat>ncols) {
            atable=atable+'   <tr>'+arow+'</tr> \n ';
            arow='';
            iat=1;
          }
          igoo=iat-1;
          if (igoo>iastyle) igoo=iastyle;
          bstyle=astyle[igoo];
          atd='<td '+bstyle+'>'+alist[m]+'</td>';
          arow=arow+atd ;
       }
   }
   if (arow!=='') {
          atable=atable+'<tr>'+arow+'</tr> \n ';
          arow='';
   }
}

atable=atable+'\n</table> ';
return atable;
}


//=================
// verify that a list of named radio buttons were selected (one of the buttons sharing a name were selected)
// alerts the prompt if one or more not answered, and returns false
// returns true if all were answerd
// alist should be a csv of the radio names: i.e.;  'BUTTON1,BUTTON3,BUTTON4'

function checkRadiosDone(fname,alist,aprompt) {
   var buttons,buttons,oks,j,a1,blen,jj;
   if (arguments.length<3) aprompt='Please answer all of the questions ';
   alist=trim(alist);
   buttons=alist.split(',');
   oks=[];
   for (j=0;j<buttons.length;j++)oks[j]=0;

   for (var j=0;j<buttons.length;j++) {
       a1=trim(buttons[j]);
       blen=document[fname][a1].length;
       for (var jj=0;jj<blen;jj++) {
         if (document[fname][a1][jj].checked) {
           oks[j]=1;
           break;
         }
       }
   }
   for (j=0;j<buttons.length;j++) {
      if (oks[j]==0) {
         alert(aprompt);
         return false;
       }
    }
    return true;

}

//====================
function show_dollars(avalue) {
 avalue=parseFloat(avalue+0.00001);
 var foo=avalue.toFixed(2) ;
 if (foo>=0) return '$'+foo ;
 foo=-foo; foo=foo.toFixed(2) ;
 return '-$'+foo;
}

// from:  http://www.mredkj.com/javascript/numberFormat.html
function addComma(nStr) {
	nStr += '';
	x = nStr.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
	return x1 + x2;
}



//==============
// return a list of words, or the nth word (where nth=1 means "first . Returns '' if object, or if nth > # of words
// if nth an array, get words from nth[0] to nth[1] INCLUSIVE.
// i.e.;  astring="this is my string of words "
//  getWord(astring,1) = "this"
//  getWord(astring) = array of 6 elements
//  getWord(astring,7)=''
//  toget=[3,4] ;  foo=getWord(astring,'',toget)  = "my string"

function  getWord(astring,nth,adelim)   {

  var   is2,foo,foonew,a1,j,n1,n2,aa;
  if (arguments.length<2) nth=0;
  if (arguments.length<3) adelim=''; adelim=trim(adelim);

  if (typeof(astring)=='object') return '' ;
  if (typeof(astring)=='number') {
        if (nth!=0) return '' ;
        return astring  ;
   }
   if (typeof(astring)=='undefined' || typeof(astring.split)!=='function' ) return 'getWord_astring_error' ;

  is2=0;
  if (typeof(nth)=='object' && nth.length && nth.length>1) is2=1;
  if (adelim=='') {
        var foo=astring.split(' ');
        var foonew=new Array() ;
        for (var j=0 ; j<foo.length;j++){
           var a1=trim(foo[j]);
           if (a1=='') continue ;
           foonew[foonew.length]=a1 ;
        }
   } else {
        if (typeof(astring)=='undefined' || typeof(astring.split)!=='function') return 'getWord_delim_error';
        var foonew=astring.split(adelim);
   }

   if (is2==1) {                        // subset of the words
       n1=parseInt(nth[0]) ; n2=parseInt(nth[1]);
       if (isNaN(n1) || isNaN(n2)) return ''  ;
       if (n1>foonew.length || n2 <1) return '';
       if (n1<1) n1=1 ; if (n2>foonew.length) n2=foonew.length ;
       if (n1==n2) return foonew[n1-1] ;
       aa=adelim ; if (aa.length==0) aa=' ';
       var arf=foonew.slice(n1-1,n2) ;
       arf=arf.join(aa);
       return arf ;
   }

   if (nth>0)  {
        if (nth>foonew.length) return '' ;
        return foonew[nth-1] ;
   }
   return foonew ;                       // return the array
}

//======
// convert html tags to entties (<b> becomes &lt;b&gt;
function htmlTagsConvert(str)
{
  str = str.replace(/&/g, "&amp;");
  str = str.replace(/>/g, "&gt;");
  str = str.replace(/</g, "&lt;");
  str = str.replace(/"/g, "&quot;");
  str = str.replace(/'/g, "&#039;");
  return str;
}


// ============
/* return ie version, 0 if nont
*/

function isIE(){

    var undef=false,
        v = 3,
        div = document.createElement('div'),
        all = div.getElementsByTagName('i');

    while (
        div.innerHTML = '<!--[if gt IE ' + (++v) + ']><i></i><![endif]-->',
        all[0]
    );

    return v > 4 ? v : undef;

};

//=== set a global temp variable (useful for onBlur and onChange
function setGlobalTemp(aval) {
  globalTemp=aval;
  return 1;
}


//==========================
// help stuff: toggles display of help text in a special "moveable" box.
//  example:   <help title="the full gas price details" style="color:blue" value="??"   use="fullGasPriceHelp"> </help>
//  Sadly, <help ....  /> doesn't seem to work in firefox, so you MUST have  </help>
//
//  Value:
//     If there is nothing between the <help> and the </help>:
//          a value attribute is read and used as the text of a <input type="button" ..>
//          If no value attribute, "?" is used
//    otherwise
//        a <a > is used (with the stuff between <help> and </help> the text)
//
//  use is the name of the "keyword" to display in the moveable help box  (keyword blocks are at the bottom of carCosts.html)
//  style is optional: if specified it is used. If <a> method is used, a default style of "text-decoration:underline;color:blue" is used (if no style attribute is specified)
//  title is the mouseOver title. If not specified, "Help" is used
// all other attributes are ignored
// the ii argument is not used


function initHelp(ii) {

var list1,im,a1,atitle,astyle,ause,isbutton,avalue,aelem,pp,foo;

list1=document.getElementsByTagName('help');

for (im=0;im<list1.length;im++) {
  a1=list1[im];
  atitle=readAttributeNode(a1,'title','Help');
  astyle=readAttributeNode(a1,'style','');

  ause=readAttributeNode(a1,'use','',0,1);
  if (ause=='') {
    goo=a1.getAttribute('use'); alert(' check for USE in help for '+goo);
    alert('Error in HELP: no use attribute (title='+atitle);
    javaScriptAbort(1);
  }

  isbutton=0;
  avalue=get_elemValue(a1,'','S');
  if (avalue=='') {
    avalue=readAttributeNode(a1,'value','?');
    isbutton=1;
  }
  if (isbutton==1) {
     aelem=document.createElement('input');
     aelem.setAttribute('type','button');
     aelem.setAttribute('value',avalue);
     aelem.value=avalue;
  } else {
    aelem=document.createElement('a');
    foo=document.createTextNode(avalue);
    if (astyle=='')astyle="text-decoration:underline;color:blue";
    aelem.appendChild(foo);
  }

  aelem.title=atitle;
  aelem.onclick=doHelp ;
  aelem.setAttribute('use',ause);
  aelem.setAttribute('style',astyle);

  pp=a1.parentNode;
  pp.insertBefore(aelem,a1);
}

list1=document.getElementsByTagName('help');

for (im=list1.length-1;im>=0;im--) {
  a1=list1[im];
  pp=a1.parentNode;
  pp.removeChild(a1);
}

return 1;

}

//=================
// if a <help element is clicked (actually, the input element created from the <help> element
function doHelp(e) {
  var ashow;
  if (!e) var e = window.event;   // from http://www.quirksmode.org/js/events_properties.html
  if (e.target) targ = e.target;
  else if (e.srcElement) targ = e.srcElement;
  if (targ.nodeType == 3)    targ = targ.parentNode; //safari bug

  ashow=readAttributeNode(targ,'use','');
  showKeyword(ashow);

  return false ;
}

//==============
//==========================
// more info stuff   -- creates button or link that when clicked, toggles display of a DIV/SPAN element.
//  example:   <more title="the full gas price details" style="color:blue" value="??"   use="fullGasPriceHelp"> </more>
//  Sadly, <more ....  /> doesn't seem to work in firefox, so you MUST have  </more>
//
//  Value:
//     If there is nothing between the <more> and the </more>:
//          a value attribute is read and used as the text of a <input type="button" ..>
//          If no value attribute, "..." is used
//    otherwise
//        a <a > is used (with the stuff between <more> and </more> the text)
//  Attributes used by <more>
//    use: the ID of the element (Div, span, whatever) to toggle display of. Example
//    altUse : instead of toggling display, simulate a click of another <more> -- a <more> with an id equal to altUse's value (note: altFor is a synonym for altUse)
//    value: if specified, text displayed in a button (see above for details)
//    altValue: if specified, the "value" displayed (in button or in link) is alternated between the value and this value.
//    style: optional: if specified it is used. If <a> method is used, a default style of "text-decoration:underline;color:blue" is used (if no style attribute is specified)
//    title: the mouseOver title. If not specified, "Help" is used
//    id: per usual.  This is used when an altUse attribute is specifed (in a different <more>
//
//  Note: one of altUse or use should be specified, not both. If both are specified, altUse is used.
//        altUse is a convenience: it allows you to have multiple closers, where one of the closers is the "main" closer. This "main" closer
//        can modify itself using "altValue" and "altBorder". 
//        For example, if you have <more> buttons that close the same box, the message of the "main" close button could get out of sync. Using altUse avoids this problem.

// all other attributes are ignored
// the ii argument is not used
//
// returns an array containing the ids of the created elements. These may be '' (if no id was specified in the <more>
// this returned array can be used as an input to makeMoreOpener function

// more info (open up a div)
//        <more value="button text"  use="sheet1" closeMessage="Close gas worksheet" title="Open the cost-per-gallon-of-gas worksheet">link text</a>

function initMore(ii) {

var list1,im,a1,atitle,astyle,ause,isbutton,avalue,aelem,pp,foo,nclick,altValue,arestore,altFor ;
var morelist=[],aid;

list1=document.getElementsByTagName('more');

for (im=0;im<list1.length;im++) {
  a1=list1[im];

  atitle=readAttributeNode(a1,'title','More...');
  astyle=readAttributeNode(a1,'style','');

  ause=trim(readAttributeNode(a1,'use',''));
  altFor=trim(readAttributeNode(a1,'altUse',''));
  if (altFor=='') altFor=trim(readAttributeNode(a1,'altFor',''));

  if (ause=='' && altFor=='') {
    alert('Error in MORE: no use or altUse attribute (title='+atitle);
    javaScriptAbort(1);
  }


  altValue=readAttributeNode(a1,'altValue','');

  isbutton=0;
  avalue=get_elemValue(a1,'','');
  if (trim(avalue)=='') {
    avalue=readAttributeNode(a1,'value','...');
    isbutton=1;
  }
  if (isbutton==1) {
     aelem=document.createElement('input');
     aelem.setAttribute('type','button');
     aelem.setAttribute('value',avalue);
     aelem.setAttribute('altValue',altValue);
     aelem.setAttribute('origValue',avalue);
     aelem.setAttribute('nth','0');
     aelem.value=avalue;
  } else {
    aelem=document.createElement('a');
    aelem.setAttribute('altValue',altValue);
    aelem.setAttribute('origValue',avalue);
    aelem.setAttribute('nth','0');
    foo=document.createTextNode(avalue);
    if (astyle=='')astyle="text-decoration:underline;color:blue";
    aelem.appendChild(foo);
  }

  aelem.title=atitle;
  aelem.onclick=doMore ;
  aelem.setAttribute('use',ause);
  aelem.setAttribute('altFor',altFor);
  aelem.setAttribute('style',astyle);
  aid=a1.id ;
  aelem.id=aid;
  pp=a1.parentNode;
  pp.insertBefore(aelem,a1);
  morelist.push(aid);

}

list1=document.getElementsByTagName('more');

for (im=list1.length-1;im>=0;im--) {
  a1=list1[im];
  pp=a1.parentNode;
  pp.removeChild(a1);
}

return morelist ;

}


//=================
// if a <more element is clicked (actually, the input element created from the <help> element
function doMore(e) {

  var ashow,nth,showValue,targ,altvalue,arestore,aold,altFor;
  if (!e) var e = window.event;   // from http://www.quirksmode.org/js/events_properties.html
  if (e.target) targ = e.target;
  else if (e.srcElement) targ = e.srcElement;
  if (targ.nodeType == 3)    targ = targ.parentNode; //safari bug

  altFor=readAttributeNode(targ,'altFor','');
  if (altFor!=='') {
     targ=document.getElementById(altFor);
     if (!targ) {
         abortJavaScript('Error in <more>   altfor specifed non-existent id: '+altFor) ;
     }
  }

  ashow=readAttributeNode(targ,'use','') ;
  turnDisplayOn(ashow,'toggle') ;

// change message?

  altvalue=readAttributeNode(targ,'altvalue','');
  if (trim(altvalue)=='') return false;

  nth=parseInt(readAttributeNode(targ,'nth','1'));
  if (isNaN(nth)) return false ;
  nth++ ;

// if here, got altvalue and nth, so change message
  if (nth%2==1) {
      showValue=readAttributeNode(targ,'altvalue','');
  } else {
      showValue=readAttributeNode(targ,'origvalue','');
  }
  if (typeof(targ.tagName)!=='undefined' && targ.tagName.toUpperCase()=='INPUT') {
      targ.value=showValue;
  } else {
      targ.innerHTML=showValue;
  }
  targ.setAttribute('nth',nth);

  return false ;
}

// ======================================
// modify a button (or link) so that on click it calls doClickAllMore with the correct attributes   (i.e.; add doClickAllMore as an event handler
//    aid: id of element to assign doClickAllMore to   (error if it doesn't exist)
//    alist: array of ids to "open" or "close". Ie; the array returned by initMore
//    doOpen: optional. If 1 (the default), create an "open all". If "0", create a "close all".
// Note: this will NOT change display of the "aid" element -- it just adds a onclick event handler and the needed attributes.

function makeAllMoreButton(aid,alist,doOpen) {
  var iaid,blist;

  if (arguments.length<3) doOpen="1"; doOpen=trim(doOpen);
  iaid=document.getElementById(aid);
  if (!iaid) abortJavasScript('Error: in makeAllMoreButton no such id: '+aid);
  blist=alist.join(' ');
  iaid.onclick=doClickAllMore;
  iaid.setAttribute('allMore',blist);
  iaid.setAttribute('doOpen',doOpen);
  return 1;
}


// ======================================
// given a space delimited list of ids of <more> elements, open or close all the associated boxes (in their "use" attributes
// Be careful to use only ids specified in a <more>, not in the target (as identified in a use) of this <more>
// Basically, makeMoreOpener simulates closing all of the more buttons, and then  (if doOpen=1) clicking on each of them
// alist: list of ids (strings, not nodes) to "open" or "close". I.e.; string version of array returned by initMore
//       Note: blank or "non existent" ids are ignored (an error does not happen)
// doOpen: default is 0. If 1, "open" all the "use" elements. If 0, close them all

function clickAllMore(alist0,doOpen) {
var im,a1,targ,alist,a1,ashow,altvalue,nth;

alist=getWord(alist0);
if (arguments.length<2) doOpen='1';
doOpen=trim(doOpen);

for (im=0;im<alist.length;im++) {

  a1=trim(alist[im]);
  if (a1=='') continue ;
  targ=document.getElementById(a1);
  if (!targ) continue ;

  ashow=readAttributeNode(targ,'use','') ;
  if (doOpen==1) {
     turnDisplayOn(ashow) ;
     nth=1;
     showValue=readAttributeNode(targ,'altvalue','');
  } else {
     turnDisplayOn(ashow,'none') ;
     nth=0;
     showValue=readAttributeNode(targ,'origvalue','');
  }

// change message?

   if (typeof(targ.tagName)!=='undefined' && targ.tagName.toUpperCase()=='INPUT') {
      targ.value=showValue;
   } else {
      targ.innerHTML=showValue;
   }
   targ.setAttribute('nth',nth);

 }                              // alist

 return 1 ;
}



// ======================================
// event function that calls clickAllMore. This is  used by makeAllMoreButton
// allMore attribute must exist. It should be a space delimited list of ids to "click" -- the ids of <more> elements
// If no allMore attribute, nothing happens
// If a doOpen=1 attribute is defined:
//   doOpen="1" (or no doOpen specified): open all <more>
//   doOpen="0" close.
// Default of doOpen is '1'

function doClickAllMore(e) {

  if (!e) var e = window.event;   // from http://www.quirksmode.org/js/events_properties.html
  if (e.target) targ = e.target;
  else if (e.srcElement) targ = e.srcElement;
  if (targ.nodeType == 3)    targ = targ.parentNode; //safari bug

  alist=readAttributeNode(targ,'allMore','');
  if (trim(alist)=='') return 0 ;

  ado=readAttributeNode(targ,'doOpen','1');
  clickAllMore(alist,ado);
  return 1;
}


//=================================
// replicate a tree, with updating of id/name/for and group attributes, and possibly value (or innerHTML)
// You specify the ID of a sub-tree (the root node) to replicate
// You also specify a group name. Often, this is a number, but it can be any string containing letters, digits, or an underscore  -- but NO SPACES
// In this subtree, all elements are examined.
//  If they do NOT have a "group" attribute, they are copied as is
//  If they do have a group attribute,
//     1) the value of the group attribute is changed to the group name.
//     2) A set of attribute (supplied as argument) are checked. For example: ID, NAME, USE, FLAG, REFVALUE, WATCH, and FOR. Any * in the value is replaced by the group name.
//     3) if a showgroup="1" is specified, the value (value attribute or innerHTML) of the element is  modified (* replaced by the group name)
//   The element is copied (with modified values of group, id, name, and label attributes
//
// A pointer to this replicated tree is returned. It can then be inserted using standard dom functions (such as insertBefore )
//  If an error occurs, a string is returned containing the error message (so check the type of the return for string)
//
//  Arguments:
//   aid : id (string) of the root element of the tree to replicate
//         Or, aid can be a pointer to a node (i.e.; one returned from a prior call to  replicateTreeWithUpdate
// igroup:  string (digits, characters, or underscore -- NO spaces) that will replace * attList attributes
//          If igroup='*', just copy the node, don't do the group updates. This can be useful if you intend to make several copies at different times:
//          one can use the replicated node rather the the node in the dom tree
//  oldDispo: Optional. If specified, what to do with the old node. This is used only if the oldNode is in a DOM tree (if it doesn't have a parentnode, oldDispo is ignored)
//          values are (case insensitive)
//                   ''  : keep the old element
//                   remove : remove the old element
//                   replace : replace the old element with the newly created element
//  newDispo : Optional. If specified, where to insert the new element. This is usually NOT used with oldDispo='replace'
//              values are:
//                     before targetId    -- insert new node before the element with id of targetId
//                     after targetId          -- insert new node after the element with id of targetId
//                     first targetId     -- place as first child of targetId
//                     last targetId     -- place as last child of targetId
//              before and after are case insenstive. id is case senstive
//   groupAtt :  attribute to check for group value. If not specified, "group" is used
//   useAtt: array of attributes (case insensitive) to check for *. If not specified, check ID.
//   showGroup: special attribute. If this is listed in useAtt, and an element has such an attribute, then
//              the value of the  element is subject to * replacement (hence, the visible value will be changed)
//              default is to NOT look for such an attriubte. To reiterate: that the value of showGroup must ALSO be in the useAtt list
//

function replicateTreeWithUpdate(aid,igroup,oldDispo,newDispo,groupAtt,useAtt,showGroup) {
   var a1,a1a,aelem,im,alist,newNode,iid;
   var letterNumber = /^[_0-9a-zA-Z]+$/;
   var a2,a2a,chk1,tchk1,ma;

  if (arguments.length<3) oldDispo=''; oldDispo=trim(oldDispo.toUpperCase());
  if (arguments.length<4) newDispo=''; newDispo=trim(newDispo);
  if (arguments.length<5) groupAtt='group' ; groupAtt=trim(groupAtt);
  if (arguments.length<6) useAtt=['id'];
  if (arguments.length<7) showGroup='' ;      showGroup=trim(showGroup.toUpperCase());


  if(typeof(aid)=='object') {
      if (!aid.cloneNode)   return 'Error: aid is an object, but does not have cloneNode support ';
      iid=aid  ;
  }   else {
     iid=document.getElementById(aid);
     if (!iid) return  'Error: no element with id ='+aid+' (so no replication possible)' ;
  }

  igroup=trim(igroup);
  if (igroup!=='*') {
    if (!igroup.match(letterNumber)) return 'Error: bad group name replicating '+aid+' (groupName can only have letters, digits, and _s): '+igroup;
  }

  newNode=iid.cloneNode(true);   // clone this tree
//  newNode.setAttribute('id',newNode.getAttribute('id')+'_'+igroup);
   if (trim(igroup)=='*') {
      alist=[];                  // a hack skip igroup processing
   } else {
      alist=newNode.getElementsByTagName('*');      // now modify it
   }

  for (im=-1;im<alist.length;im++) {
    if (im<0) {
       aelem=newNode;
    } else {
        aelem=alist[im];
    }
     agroup=readAttributeNode(aelem,groupAtt,'');
     if (agroup==='') continue ;

     aelem.setAttribute(groupAtt,igroup);

     for (ma=0;ma<useAtt.length;ma++){
        chk1=trim(useAtt[ma]); tchk1=chk1.toUpperCase();

        a1=readAttributeNode(aelem,chk1,'')

        if (a1!=='') {
          a1a=a1.replace(/\*/g,igroup);
          if (tchk1==showGroup) {            // special: set value, not attribute
             a2=get_elemValue(aelem,'');
             a2a=a2.replace(/\*/g,igroup);
             set_elemValue(aelem,a2a);
          } else {
             if (tchk1=='ID') aelem.id=a1a ;
             if (tchk1=='NAME') aelem.name=a1a ;
             aelem.setAttribute(chk1,a1a);
          }
       }     // a1 !==''

     }          // in useAtt
  }                // in alist

   if (oldDispo!=='')  {                       // disposition of old node
    pnode=iid.parentNode ;
    if (pnode!==null) {
      if (oldDispo=='REMOVE') {
        pnode.removeChild(iid);
      }
      if (oldDispo=='REPLACE') {
        pnode.insertBefore(newNode,iid);
        pnode.removeChild(iid);
      }
    }
  }  // olddispo

  if (igroup!=='*') {
    var aaid=newNode.getAttribute('id');
    var aaid2=aaid+'_'+igroup;
    newNode.setAttribute('id',aaid2);
    var zaid=newNode.getAttribute('id');
  }

   if (newDispo!=='')  {                       // placement of new node
      tt=getWord(newDispo);
      tt1=trim(tt[0].toUpperCase()) ;
      targid=trim(tt[1]);
      if (tt1=='BEFORE' || tt1=='AFTER' || tt1=='FIRST' || tt1=='LAST') {
        itarg=document.getElementById(targid);
        if (!itarg) return 'Error: can not place new tree; no such target: '+targid ;
        if (tt1=='BEFORE') {
            pnode=itarg.parentNode ;
            if (!pnode) return 'Error: unable to place tree (no parentNode) before '+targid ;
            pnode.insertBefore(newNode,itarg);
        }
        if (tt1=='AFTER') {
            pnode=itarg.parentNode ;
            if (!pnode) return 'Error: unable to place tree (no parentNode) after  '+targid ;
            pnode.insertBefore(newNode,itarg.nextSibling);
        }
        if (tt1=='LAST') {
           itarg.appendChild(newNode);
        }
        if (tt1=='FIRST') {
           itarg.insertBefore(newNode,itarg.firstChild);
      }
   }       // valid word
 }  // new dispo


 return newNode;
                          // group
}

//===================================
// html encode a string for a limited set of characters
// 1: ascii codes <32
//    ascii codes > 127
//  characters:    "  &  ' ( )  ,  < >
function someHTMLEncode(str){

  var doem={34:1,38:1,39:1,40:1,41:1,44:1,60:1,62:1,37:1} ;
  var i = str.length, aRet = [];

  while (i--) {
    var iC = str[i].charCodeAt();
    if (iC<32 || iC>127 || typeof(doem[iC])!=='undefined') {
        aRet[i] = '&#'+iC+';';
    } else {
        aRet[i] = str[i];
      }
  }
  return aRet.join('');
}

//===================================
// decode  limited set of html enties in string: that have a syntax of &#nn;
// &#nn; characters for the following will be decoded (converted back to the character:    "  &  ' ( )  ,  < >  %
// also, entity names (some of them non-standard) are recoqnized:  quot amp apost lparen rparen comma lt gt
//
// example : &#38; or &38; become '&',  &#41; or &rparen; become ")"
//
// If others is specified, other string replacements (all occurences) will happen
// Others should be an array of objects. Each object should have two fields:  toFind (the thing to find in the string), and replaceWith (the new value)
// Example: others=[]; others[0]={toFind:' this.id ',toReplace:thisElement}


function someHTMLDecode(str,others,justOthers){

 var aa,a1,aorig,areplace,m,a,i,doem;
 if (arguments.length<3) justOthers=0;
 justOthers=trim(justOthers);

 if (justOthers!=='1') {
   doem={'34':'"', '38':'&', '39':"'", '40':'(', '41':')', '44':",", '60':'<', '62':'>','quot':'"','amp':'&','gt':'>','lt':'<','lparen':'(','rparen':')','comma':',','apost':"'",'37':'%'} ;
   i = str.length, aRet = [];

  for (a in doem) {
      if (isNaN(a)) {
        aa=RegExp('&'+a+';','g') ;
      } else {
         aa=RegExp('&#'+a+';','g') ;
      }
      str=str.replace(aa,doem[a]);
  }
}


 if (arguments.length>1) {           // other replacements
   for (m=0;m<others.length;m++) {
       a1=others[m];
       aorig=a1.toFind ;
       aa=RegExp(aorig,'g') ;
       areplace=a1.replaceWith ;
      str=str.replace(aa,areplace);
   }
 }

  return str;
}


//===================
//===============
// parse from the var, between first d1 and first d2 characters (following d1)

function parseUsing(thevar,d1,d2 ) {
  var allp=1 ;
if (typeof(thevar)=='undefined') {
    writeStatus('%WARNING: Undefined in parseUsing ');
   return '' ;
 }
 if (arguments.length<2) return thevar ;
 if (arguments.length<3) d2='' ;
 allp=trim(allp);
var a3=new Array('','','') ;

 var dares='' ;
if (trim(d1)==='') {                  // no first delim means :"everything upto the 2nd delim"
      var idb=thevar.indexOf(d2) ;
      if (idb<1) {                // cant find 2nd delim.. so use entire string
         if (allp!=1)  return thevar ;
         a3[1]=thevar ;                 // no 2nd delimiter, everything matches
         return a3 ;
      }
     if (allp!=1)  return thevar.substr(0,idb) ;
      a3[1]=thevar.substr(0,idb) ;                 // match is everything up to this 2nd delminter -- there is no "leading" portion
      a3[2]=thevar.substr(idb+1) ;
      return a3 ;
}
if (trim(d2)==='') {                   // no second delim means "everything after the first delim"
      var ida=thevar.indexOf(d1,ida);
      if (ida<1)  {                       // cant find first delim, so use ''
         if (allp!=1) return '';                     // no first delim, so nothing to return
         a3[0]=thevar ;                        // no match to first, so all in preceder
         return a3 ;
      }
      if (allp!=1)  return thevar.substr(ida+1) ;
      a3[0]=thevar.substr(0,ida) ;                      // no trailer
      a3[1]=thevar.substr(ida+1) ;
      return a3 ;
}

//there are 2 delimters

 var ida=thevar.indexOf(d1,ida);
 if (ida==-1) {
      if (allp!=1)    return '' ;                     // can't find first
      a3[0]=thevar ;
      return a3 ;
 }

 var idb=thevar.indexOf(d2,ida+1);
 if (idb<ida) {
      if (allp!=1)  return thevar.substr(ida+1) ;               // cant find 2nd
      a3[0]=thevar.substr(0,ida)  ;
      a3[1]=thevar.substr(ida+1)  ;
      return a3 ;
}

var tt=idb-(ida+1) ;

if (allp!=1) return thevar.substr(ida+1,tt);
a3[0]=thevar.substr(0,ida);
a3[1]=thevar.substr(ida+1,tt);
a3[2]=thevar.substr(idb+1) ;
return a3 ;

}

//=====================
// display a message and clumsily exit javascript
function abortJavaScript(amess) {
  if (arguments.length>0) alert(amess);
  abortJavaScriptNow();                          // call non existent funtion that yields informativeish error message
}



//=-====================
// create an emprical pdf  returned as an array.
// range of support of this pdf is integers from minval to maxval.
// You provide a "template" set of "x values" and their "probablities" (these do NOT have to be a pdf)
// 4 inputs:
//  minval: minimum value with + probablity (the bottom of the range of support)
// maxval: maximum value with + probability (the top of the range of support)
// refs: m element array of values. Must be strictly increasing.
// probs: m element of probablities for each of these values
//
// Return:  array defined from minval to maxval, in increments of 1. Call this array pdfNew
//          pdfNew will have a length of N, with N=maxval+1-minval
//          each element  pdfNew is a discrete probablity. The sum of these will add to 1.0
//          These probablities are computed by
//             a) converting the refs & probs into a piecewise linear pdf. Call this refPdf
//             b)  mapping  each of the N values (the indices) of pdfNew to refPdf
//             c)  Normallizing the N values of pdfNew
//         The [0] element of  refs corresponds to minval, the [m-1] corresponds to maxval
//         Note that the refs values can be arbitarily spaced, they do not have to be equidistant from each other
//         The probs do NOT have to sum to 1.0 (the normalization of pdfNew will take care of that)
//         Typically, there m is less than n, but that is not required
//
// Note: minval and maxval are converted to integers (they can be negative), with maxval>minval.

function xmakeEmpiricalPdf(minval,maxval,refs,probs) {


 // make sure refs is legit

 if (refs.length<2) {
    alert('Error in makeEmpricalPdf: refs must be at least 2 elements long ');
    return null;
 }
 if (refs.length!==probs.length) {
    alert('Error in makeEmpricalPdf: refs has '+refs.length+' elements, but probs has '+probs.length+' elements.');
    return null;
 }
 for (var m=0;m<refs.length-1;m++) {
  m1=m+1;
  if (refs[m]>=refs[m1]) {
    alert('Error in makeEmpricalPdf: not strictly increasing refs (index '+m+'= '+refs[m]+ ', index '+m1+' = '+refs[m1]);
    return null   ;
  }
  if (probs[m]<0) {
    alert('Error in makeEmpricalPdf: probs element '+m+' is < 0 ('+probs[m]+')');
    return null  ;
  }
}

 maxval=parseInt(maxval); minval=parseInt(minval);
 if (minval>=maxval) {
    alert('Error in makeEmpricalPdf: minval ('+minval+') is not greater than maxval ('+maxval+')');
    return null   ;
  }

// arguments are legit, so proceed

 newRange=maxval-minval;
 newPdfs=[];
 oldMin=refs[0]; oldMax=refs[refs.length-1] ;
 oldRange=oldMax-oldMin;
 for (i0=0;i0<refs.length-1;i0++) {
    o1=refs[i0]; o2=refs[i0+1];  oRange=o2-o1 ;
    n1=minval + (((o1-oldMin)/oldRange)*newRange);  n1=parseInt(n1);
    n2=minval + (((o2-oldMin)/oldRange)*newRange) ; n2=parseInt(n2);
    nrange=n2-n1 ;
    op1=probs[i0] ; op2=probs[i0+1]; opRange=op2-op1 ; opdelta=opRange/nrange ;
    for (var jj=0;jj<=nrange;jj++) {
        jm=n1+jj ;
        aprob=op1+ (jj* opdelta) ;
        newPdfs[jm]=aprob;
    }
  }

  psum=0;

  for (var j=minval;j<=maxval;j++) {
     psum=psum+newPdfs[j] ;                   // normalize
    }
  for (var j=minval;j<=maxval;j++) newPdfs[j]=newPdfs[j]/psum ;


  return newPdfs;

}


// ----------
// return time and/or date
//  If no arguments: return  hh:mm:ss xM 
// timeType:  
//      0= javascript milliseconds
//          otherwise, incldue time
//      1 =  mm:hh:ss xM

// dateType:
//      1=  date Month Year
//      2 = day-of-week, date Month Year
//
// if timeType and dateType ==2 : return as: xday Month date year hh:mm:ss GMT-xxxx (tz)

// if both time and date specified, format is date-string, time-string 

function get_currentTime(timeType,dateType) {
  var Hours,Mins,Time,Sec,atime,adate,jdate,amonth,ayear,aday;
 

   if (arguments.length<1 ) timeType=1;
   if (arguments.length>0) {
       if (typeof(timeType)=='object' || trim(timeType)==='') timeType=1;
    }
   if (arguments.length<2) dateType=0 ;

  Stamp = new Date();
  atime=''; jdate='';

  if (timeType==0) return Stamp.getTime()  ;                    // internal time (milliseconds since 1970)

  if (timeType==2 && dateType==2) {
        adate=Stamp.toString();
        return adate ;
   }
  if (timeType!=0) {
      Hours = Stamp.getHours();
      if (Hours >= 12) {
         Time = "PM";
       }
       else {
         Time = "AM";
       }
       if (Hours > 12) {
        Hours -= 12;
       }
        if (Hours == 0) {
         Hours = 12;
       }
       Mins = Stamp.getMinutes();
       if (Mins < 10) {   Mins = "0" + Mins } ;
   
       Secs = Stamp.getSeconds();
       if (Secs < 10) {   Secs = "0" + Secs } ;
       atime=Hours + ':' + Mins + ':' +  Secs + ' ' + Time ;

   }

  if (dateType!=0) {
     adate=Stamp.toString();
     var foo=adate.split(' ');
     aday=foo[0]; amonth=foo[1]; adate=foo[2] ; ayear=foo[3];
     jdate=adate+' '+amonth+' '+ayear+' ';
     if (dateType==2 )  jdate=aday + ', ' + jdate;
  }

  atime=jdate+atime ;
  return atime ;
}


//=========================================================
// display string a new new HTML window. if cvt=1, convert <  > and & to entity codes
function  displayStringInWindow(stuff,cvt,astext){
  var stuff2;
  if (arguments.length<3) astext=0;
  stuff2=stuff;
  if (cvt==1) {
      stuff2=stuff2.replace(/\&/g,'&amp;');
      stuff2=stuff2.replace(/\>/g,'&gt;');
      stuff2=stuff2.replace(/\</g,'&lt;');
  }
  var ww=window.open('','sdata',"toolbar=0,menubar=0,directories=0,scrollbars=1,resizable=1" );
  if (astext==2) {
       ww.document.open('text/plain');
  } else if (astext==1)  {
        ww.document.open('text/xml');
  } else {
    ww.document.open('text/html');
  }

/*
  if (astext!=1) {
    ww.document.open('text/html');
  } else {
    if (astext!=2) {
        ww.document.open('text/xml');
    } else {
       ww.document.open('text/plain');
    }
  }
*/

  ww.document.writeln(stuff);
  ww.document.close();
  ww.focus();
  return 1;
}
